extern "C" {

#include "stdlib.h"
#include "keyboard.hpp"
#include "keyboard_syscalls.h"
#include "disp_tools.hpp"
#include "display_tools.h"
#include "app_syscalls.h"
#include "convert_syscalls.h"
#include "system_syscalls.h"
#include "heap_syscalls.h"
#include "RTC_syscalls.h"
#include "STD_syscalls.h"
#include "convert_tools.h"
#include "mcs_syscalls.h"
#include "fxCG_display.h"
#include "misc_tools.h"
#include "fxCG_registers.h"
#include "StrList.hpp"
#include "ListView.hpp"
#include "STATUS_ICONS.hpp"
#include "mcs.hpp"
#include "MemViewClass.hpp"

int test_global[10];
static int test_initialized = 0x12345678;

// unsigned int memviewer( unsigned int*start_address, int mode );
void Verify_Syscalls( void );

// test
int AsmTest( void );
int AsmTest2( void );
// test
int GetPR( void );


// some constants to save certain values to main memory
#define INSIGHTDIRNAME "@INSIGHT"
#define INSIGHT_MEMADDR "MEMADDR"
#define INSIGHT_SYSCALL_VERIFY_UNLOCK "SYSCALLS"
#define INSIGHT_SYSCALL_VERIFY_UNLOCK_VALUE 0x12345678

//
void F1_Handler(){
TMemView mv;
unsigned int start_address, memviewer_result;  
int size;
	
	if ( !MCSGetDlen2( INSIGHTDIRNAME, INSIGHT_MEMADDR, &size ) ){
		if ( MCSGetData1( 0, size, &start_address ) ) start_address = 0x80020000;
	}else start_address = 0x80020000;
	
	mv.SetAddress( start_address );
	mv.browse();
	start_address = mv.GetAddress();
	
//	memviewer_result = memviewer( &start_address, 0 );
	
	if ( MCSGetDlen2( INSIGHTDIRNAME, INSIGHT_MEMADDR, &size ) ){
		MCSPutVar2( INSIGHTDIRNAME, INSIGHT_MEMADDR, sizeof( start_address ), &start_address );
	}else{
		MCSOvwDat2( INSIGHTDIRNAME, INSIGHT_MEMADDR, sizeof( start_address ), &start_address, 0 );
	};
}

const int keyboard_register = 0xA44B0000;
#define EXIT_ROW 6
#define EXIT_BIT 0x0800

//
int QuickExitCheck( void ){
int i = *(unsigned short*)(keyboard_register+EXIT_ROW) & EXIT_BIT;
	while ( *(unsigned short*)(keyboard_register+EXIT_ROW) & EXIT_BIT );
	return i;
};

//
void F2_Handler(){
int key = 0, lastkey;
int iContinue = 1;
unsigned char hb[15];
int column, row;
unsigned short keycode;
	hb[4] = 0;
	while( iContinue ){
		lastkey = key;
		StatusArea( "INSIGHT keycodes" );
		locate_OS( 1, 1 );
		PrintLine( "Keycodes:", 21 );
		locate_OS( 1, 7 );
		PrintLine( "Ac/ON -> EXIT to exit", 21 );
		WordToHex( key, hb );
		locate_OS( 1, 2 );
		PrintLine( "SDK     :", 21 );
		locate_OS( 10, 2 );
		PrintLine( hb, 21 );
		
		key = PRGM_GetKey();
		itoa( key, hb );
		hb[10] = 0;
		locate_OS( 1, 3 );
		PrintLine( "PRGM    :", 21 );
		locate_OS( 10, 3 );
		PrintLine( hb, 21 );
		
        GetKeyWait_OS( &column, &row, KEYWAIT_HALTOFF_TIMEROFF, 0, 0, &keycode );		
		key = column;
		key = key << 8;
		key = key + row;
		WordToHex( key, hb );
		locate_OS( 1, 4 );
		PrintLine( "MATRIX  :", 21 );
		locate_OS( 10, 4 );
		PrintLine( hb, 21 );
		
		keycode = *(unsigned short*)(keyboard_register+0x0C);
		WordToHex( keycode, hb );
		hb[4]=0;
		locate_OS( 1, 5 );
		PrintLine( "A44B000C:", 21 );
		locate_OS( 10, 5 );
		PrintLine( hb, 21 );
		
		GetKey( &key );
		if (( key == KEY_CTRL_EXIT ) && ( lastkey == KEY_CTRL_AC )) iContinue = 0;
	}
}

// short to binary
void WordToBin( unsigned short value, unsigned char*p ){
int i;
	for (i=0;i<16;i++){
		if ( value & 0x8000 ) p[i] = '1';
		else p[i] = '0';
		value <<= 1;
	}	
	p[16] = 0;
}

//
void F3_Handler(){
unsigned short key;
int iContinue = 1;
int i;
int column, row;
unsigned short keycode;
unsigned char hb[20];
	StatusArea( "INSIGHT keyboard register" );
	
	IntToHex( keyboard_register, hb );
	hb[8]=0;
	locate_OS( 1, 1 );
	PrintLine( hb, 21 );
	locate_OS( 1, 8 );
	PrintLine( "Ac/ON and 0 to exit", 21 );
	while (iContinue){
		keycode = *(unsigned short*)(keyboard_register+0xC);
		WordToHex( keycode, hb );
		hb[4]=0;
		locate_OS( 10, 1 );
		Print( hb );
		
        GetKeyWait_OS( &column, &row, KEYWAIT_HALTOFF_TIMEROFF, 0, 0, &keycode );		
		key = column;
		key = key << 8;
		key = key + row;
		WordToHex( key, hb );
		locate_OS( 16, 1 );
		Print( hb );

		for (i=0;i<6;i++){
			key = *(unsigned short*)(keyboard_register+2*i);
			if ( key == 0x4001 ) iContinue = 0;
			WordToHex( (keyboard_register+2*i) & 0xFFFF, hb );
			hb[4]=0;
			locate_OS( 1, i+2 );
			PrintLine( hb, 21 );
			WordToBin( key, hb );
			locate_OS( 6, i+2 );
			PrintLine( hb, 21 );
		}	
		Bdisp_PutDisp_DD();
	}
}

void F4_Handler(){
int iContinue = 1;
int batlev, key;
unsigned char hb[15];
	StatusArea( "INSIGHT battery" );
	locate_OS( 1, 1 );
	PrintLine( "Battery:", 21 );
	while (iContinue){
		batlev = GetMainBatteryVoltage( 1 );
		itoa( batlev, hb );
		locate_OS( 1, 2 );
		PrintLine( hb, 21 );
		locate_OS( 6, 2 );
		PrintLine( "(syscall 0x1186)", 21 );
		key = *(unsigned char*)P11DR;
		WordToHex( key & 0xFFFF, hb );
		hb[4] = 0;
		locate_OS( 1, 3 );
		Print_OS( hb, 0, 0 );
		locate_OS( 6, 3 );
		Print_OS( "(7200 port V)", 0, 0 );
		if ( QuickExitCheck() ) iContinue = 0;
		Bdisp_PutDisp_DD();
	}
}

//
int CheckTime( unsigned char*timestr ){
	if ( timestr[0] != 0x20 ) return 0;
	if ( timestr[2] < 0x01 ) return 0;
	if ( timestr[2] > 0x12 ) return 0;
	if ( timestr[3] < 0x01 ) return 0;
	switch ( timestr[ 2 ] ){
		case 1 : case 3 : case 5 : case 7 : case 8 : case 10 : case 12 :
			if ( timestr[3] > 0x31 ) return 0;
			break;
		case 4 : case 6 : case 9 : case 11 :
			if ( timestr[3] > 0x30 ) return 0;
			break;
		case 2 :
			if ( ( ( ( timestr[1] & 0xF0 ) >> 4 )*10 + ( timestr[1] & 0x0F ) ) & 0x03 ){
				if ( timestr[3] > 0x28 ) return 0;
			}else{	
				if ( timestr[3] > 0x29 ) return 0;
			}
			break;
	}
	if ( timestr[4] > 0x23 ) return 0;
	if ( timestr[5] > 0x59 ) return 0;
	if ( timestr[6] > 0x59 ) return 0;
	return 1;
}

#define	XDATE 6
#define	XTIME 1
#define	YDATE 1
#define	YTIME 2

//
void DisplayTimeStr( unsigned char*timestr, unsigned int millisecond ){
unsigned char hb[15];
unsigned int year;
	ByteToHex( timestr[3], hb );
	hb[2]=0;
	locate_OS( XDATE, YDATE );
	Print_OS( hb, 0, 0 );
	Print_OS( ".", 0, 0 );
	ByteToHex( timestr[2], hb );
	hb[2]=0;
	Print_OS( hb, 0, 0 );
	Print_OS( ".", 0, 0 );
	year = timestr[0];
	year = ( year << 8 ) + timestr[1];
	WordToHex( year, hb );
	hb[4]=0;
	Print_OS( hb, 0, 0 );
	
	locate_OS( XTIME, YTIME );
	ByteToHex( timestr[4], hb );
	hb[2]=0;
	Print_OS( hb, 0, 0 );
	
	Print_OS( ":", 0, 0 );
	ByteToHex( timestr[5], hb );
	hb[2]=0;
	Print_OS( hb, 0, 0 );
	
	Print_OS( ":", 0, 0 );
	ByteToHex( timestr[6], hb );
	hb[2]=0;
	Print_OS( hb, 0, 0 );
	
	Print_OS( ".", 0, 0 );
	itoa( millisecond, hb );
	PrintLine( hb, 21 );
}

//
void incxpos( int&xpos, int ypos ){
	switch (ypos){
		case YDATE:
			if (xpos<XDATE+9) xpos++;
			if (xpos==XDATE+2) xpos++;
			if (xpos==XDATE+5) xpos++;
			break;
		case YTIME:
			if (xpos<XTIME+7) xpos++;
			if (xpos==XTIME+2) xpos++;
			if (xpos==XTIME+5) xpos++;
			break;
	}
}

void Timer_Dummy_Handler(){
}

void F5_Handler(){
int iContinue = 1;
int key, loops=0;
char goedit=0;
int xpos=XDATE, ypos=YDATE;
unsigned char hb[15];
unsigned char timestr[8];
unsigned char timestr_shadow[8];
unsigned int hour, minute, second, millisecond, ticks;
unsigned int year, month, day, timer, ix, i0;

	year = *(unsigned short*)(RTC_port+0xE);
	if (year != 0x2011){
		RTC_Reset( 1 );
		timestr[0] = 0x20;
		timestr[1] = 0x11;
		timestr[2] = 0x01;
		timestr[3] = 0x01;
		timestr[4] = 0x00;
		timestr[5] = 0x00;
		timestr[6] = 0x00;
		RTC_SetDateTime( timestr );
	};
	
	timer = Timer_Install( 0, (void*)Timer_Dummy_Handler, 1000 );
	if ( timer >= 5 ) Timer_Start( timer );
	i0 = *(unsigned int*)P7305_EXTRA_TMU5_COUNT;
	
	StatusArea( "INSIGHT RTC" );
	locate_OS( 1, 1 );
	PrintLine( "RTC:", 21 );
	while (iContinue){
		day = *(unsigned char*)(RTC_port+0xA);
		month = *(unsigned char*)(RTC_port+0xC);
		year = *(unsigned short*)(RTC_port+0xE);
		RTC_GetTime( &hour, &minute, &second, &millisecond );
		timestr[0] = year >> 8;
		timestr[1] = year & 0xFF;
		timestr[2] = month;
		timestr[3] = day;
		timestr[4] = hour;
		timestr[5] = minute;
		timestr[6] = second;
		
		DisplayTimeStr( timestr, millisecond );
		
		locate_OS( 1, 3 );
		ticks = RTC_GetTicks();
		itoa( ticks, hb );
		Print_OS( hb, 0, 0 );
		PrintLine( " syscall 02C1", 21 );
		
		locate_OS( 1, 4 );
		itoa( ++loops, hb );
		Print_OS( hb, 0, 0 );
		PrintLine( " (loop count)", 21 );
		
		locate_OS( 1, 5 );
		PrintLine( "P7305_EXTRA_TMU", 21 );
		locate_OS( 1, 6 );
		ix = i0 - *(unsigned int*)P7305_EXTRA_TMU5_COUNT;
		itoa( ix, hb );
		Print( hb );
		
		if (goedit){
			Cursor_SetFlashOn( 0 );
			while (goedit){
				locate_OS( xpos, ypos );
				GetKey( &key );
				for (ix=0;ix<8;ix++)timestr_shadow[ix]=timestr[ix];
				switch (key) {
					case KEY_CHAR_0 : 
					case KEY_CHAR_1 : 
					case KEY_CHAR_2 : 
					case KEY_CHAR_3 : 
					case KEY_CHAR_4 : 
					case KEY_CHAR_5 : 
					case KEY_CHAR_6 : 
					case KEY_CHAR_7 : 
					case KEY_CHAR_8 : 
					case KEY_CHAR_9 : 
						switch (ypos){
							case YDATE :
								switch (xpos){
									case XDATE : timestr[3] = ( timestr[3] & 0x0F ) + ( key << 4 ); break;
									case XDATE+1 : timestr[3] = ( timestr[3] & 0xF0 ) + ( key & 0x0F ); break;
									case XDATE+3 : timestr[2] = ( timestr[2] & 0x0F ) + ( key << 4 ); break;
									case XDATE+4 : timestr[2] = ( timestr[2] & 0xF0 ) + ( key & 0x0F ); break;
									case XDATE+6 : timestr[0] = ( timestr[0] & 0x0F ) + ( key << 4 ); break;
									case XDATE+7 : timestr[0] = ( timestr[0] & 0xF0 ) + ( key & 0x0F ); break;
									case XDATE+8 : timestr[1] = ( timestr[1] & 0x0F ) + ( key << 4 ); break;
									case XDATE+9 : timestr[1] = ( timestr[1] & 0xF0 ) + ( key & 0x0F ); break;
								}; break;
							case YTIME :
								switch (xpos){
									case XTIME : timestr[4] = ( timestr[4] & 0x0F ) + ( key << 4 ); break;
									case XTIME+1 : timestr[4] = ( timestr[4] & 0xF0 ) + ( key & 0x0F ); break;
									case XTIME+3 : timestr[5] = ( timestr[5] & 0x0F ) + ( key << 4 ); break;
									case XTIME+4 : timestr[5] = ( timestr[5] & 0xF0 ) + ( key & 0x0F ); break;
									case XTIME+6 : timestr[6] = ( timestr[6] & 0x0F ) + ( key << 4 ); break;
									case XTIME+7 : timestr[6] = ( timestr[6] & 0xF0 ) + ( key & 0x0F ); break;
								}; break;
						}
						if (!CheckTime( timestr))for (ix=0;ix<8;ix++)timestr[ix]=timestr_shadow[ix];
						else{
							incxpos( xpos, ypos );
							DisplayTimeStr( timestr, 0 );
						}
						break;
					case KEY_CTRL_RIGHT : incxpos( xpos, ypos ); break;
					case KEY_CTRL_LEFT :
						switch (ypos){
							case YDATE:
								if (xpos>XDATE) xpos--;
								if (xpos==XDATE+2) xpos--;
								if (xpos==XDATE+5) xpos--;
								break;
							case YTIME:
								if (xpos>XTIME) xpos--;
								if (xpos==XTIME+2) xpos--;
								if (xpos==XTIME+5) xpos--;
								break;
						}
						break;
					case KEY_CTRL_UP :						
					case KEY_CTRL_DOWN :
						switch (ypos){
							case YDATE:
								ypos = YTIME;
								xpos = XTIME;
								break;
							case YTIME:
								ypos = YDATE;
								xpos = XDATE;
								break;
						}
						break;
										
					case KEY_CTRL_EXE : 
						RTC_SetDateTime( timestr );
					case KEY_CTRL_EXIT : 
						Cursor_SetFlashOff();
						goedit=0; 
						ticks = RTC_GetTicks();
						while (!RTC_Elapsed_ms( ticks, 100 ));
						break;
				}
			}
		}else{
			key = PRGM_GetKey();
			Bdisp_PutDisp_DD();
			switch (key) {
				case KEY_PRGM_RIGHT :
				case KEY_PRGM_LEFT :
				case KEY_PRGM_UP :
				case KEY_PRGM_DOWN : goedit=1; break;
				case KEY_PRGM_EXIT : iContinue = 0; break;
			}
		}
	}
	if ( timer >= 5 ){
		Timer_Stop( timer );
		Timer_Deinstall( timer );
	}	
}

#define NSHAPES 100

const unsigned short TestGlyph0[ 18 ] = 
{ 0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0F00, 
  0x3FC0, 
  0x3FC0, 
  0x7FE0, 
  0x7FE0, 
  0x7FE0, 
  0x7FE0, 
  0x3FC0, 
  0x3FC0, 
  0x0F00, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000
  };

const unsigned short MarkGlyph[ 18 ] = 
{ 0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x1980, 
  0x1F80, 
  0x0F00, 
  0x0F00, 
  0x1F80, 
  0x1980, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000
  };
  
const unsigned short TestGlyph2[ 18 ] = 
{ 0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  0xFFFF, 
  };



//
int MoveOne( TBdispFillArea a[], TShapeProps sp[], int idx ){
int j, k;
int overlap;
int xd, yd;
	// try move x
	a[idx].x1 += sp[idx].dx;
	// detect wall collision
	if ( a[idx].x1 >= 384 - sp[idx].wx){
		sp[idx].dx = -sp[idx].dx;
		a[idx].x1 += sp[idx].dx;
		sp[idx].dx = -1;  // cold wall
		return 0;
	}
	// detect wall collision
	if ( a[idx].x1 <= 1){
		sp[idx].dx = -sp[idx].dx;
		a[idx].x1 += sp[idx].dx;
		sp[idx].dx = 3;  // hot wall
		return 0;
	}
	// detect object collision
	for (j=0;j<NSHAPES;j++){
		overlap = 0;
		if ( j != idx ){
			xd = a[idx].x1 - a[j].x1;
			yd = a[idx].y1 - a[j].y1;
			if ( xd * xd + yd * yd < 100 ) overlap = 1;
			if ( overlap ) break;
		}
	}
	if ( overlap ){
	// object collision detected
		sp[idx].dx = -sp[idx].dx;
		a[idx].x1 += sp[idx].dx;
		k = sp[idx].dx;
		sp[idx].dx = sp[j].dx;
		sp[j].dx = -k;
		return 0;
	}
	
	// try move y
	a[idx].y1 += sp[idx].dy;
	// detect wall collision
	if ( a[idx].y1 >= 216 - sp[idx].wy){
		sp[idx].dy = -sp[idx].dy;
		a[idx].y1 += sp[idx].dy;
		return 0;
	}
	// detect wall collision
	if ( a[idx].y1 <= 1){
		sp[idx].dy = -sp[idx].dy;
		a[idx].y1 += sp[idx].dy;
		return 0;
	}
	// detect object collision
	for (j=0;j<NSHAPES;j++){
		overlap = 0;
		if ( j != idx ){
			xd = a[idx].x1 - a[j].x1;
			yd = a[idx].y1 - a[j].y1;
			if ( xd * xd + yd * yd < 100 ) overlap = 1;
			if ( overlap ) break;
		}
	}
	if ( overlap ){
	// object collision detected
		sp[idx].dy = -sp[idx].dy;
		a[idx].y1 += sp[idx].dy;
		k = sp[idx].dy;
		sp[idx].dy = sp[j].dy;
		sp[j].dy = -k;
		return 0;
	}
	
	// select a color depending on the object's "energy"
	k = abs( sp[idx].dy ) + abs( sp[idx].dx );
	switch (k){
		case 2 : sp[idx].color = 0x001F ; break;
		case 3 : sp[idx].color = 0x03FF ; break;
		case 4 : sp[idx].color = 0x07E0 ; break;
		case 5 : sp[idx].color = 0xFFC0 ; break;
		case 6 : sp[idx].color = 0xF800 ; break;
	}
	
	
	a[idx].mode = 0; // clear the object's previous image
//	Bdisp_AreaClr( &sp[idx].saved, 1, -1 );
	
//	PrintMiniGlyph( sp[idx].saved.x1, sp[idx].saved.y1, (unsigned short*)TestGlyph2, 0x52, 0x0C, 0, 0, 0, 0, 0xFFFF, 0, 0 );
	PrintMiniGlyph( sp[idx].saved.x1 , sp[idx].saved.y1-4, (unsigned short*)TestGlyph0, 0x52, 0x0C, 0, 0, 0, 0, 0xFFFF, 0, 0 );
	
	
	a[idx].mode = 1; // clear the object's actual image
	a[idx].x2 = a[idx].x1 + sp[idx].wx;
	a[idx].y2 = a[idx].y1 + sp[idx].wy;
//	Bdisp_AreaClr( &a[idx], 1, sp[idx].color );
	
//	PrintMiniGlyph( a[idx].x1, a[idx].y1, (unsigned short*)TestGlyph2, 0x52, 0x0C, 0, 0, 0, 0, 0, 0, 0 );
	PrintMiniGlyph( a[idx].x1, a[idx].y1-4, (unsigned short*)TestGlyph0, 0x52, 0x0C, 0, 0, 0, 0, sp[idx].color, 0, 0 );
	
	if ( idx == 1 ){
		PrintMiniGlyph( a[idx].x1, a[idx].y1-4, (unsigned short*)MarkGlyph, 0x52, 0x0C, 0, 0, 0, 0, 0, 0, 0 );
	// draw a dot into the special object
		// Bdisp_SetPoint_VRAM( a[idx].x1 + 6, a[idx].y1 + 5, 0 );
		// Bdisp_SetPoint_VRAM( a[idx].x1 + 6 - 1, a[idx].y1 + 5, 0 );
		// Bdisp_SetPoint_VRAM( a[idx].x1 + 6, a[idx].y1 + 5 - 1, 0 );
		// Bdisp_SetPoint_VRAM( a[idx].x1 + 6 - 1, a[idx].y1 + 5 - 1, 0 );
	}
	// remember the object's actual image
	memcpy( &sp[idx].saved, &a[idx], sizeof( TBdispFillArea ) );

/*
	vy1 = a[idx].y1 - sp[idx].wy / 2;
	vy2 = a[idx].y2 + sp[idx].wy / 2;
	if ( vy1 < 0 ) vy1 = 0;
	if ( vy2 > 215 ) vy2 = 215;
	Bdisp_PutDisp_DD_stripe( vy1, vy2 );
*/	
	return 1;

}

#define V 1

// moving boxes; demonstrates the speed of VRAM-DMAC-operations
void F7_Handler(){
TBdispFillArea ar[NSHAPES];
TShapeProps mp[NSHAPES];
int ticks, i, iwork;
	ticks = RTC_GetTicks();	// current count of 1/128 s ticks since midnight.
	random( ticks );	// randomize the random-function
	while (!RTC_Elapsed_ms( ticks, 100 ));	// wait 100 ms to let the keyboard-register relax
	
	// create the shapes
	for ( i=0;i<NSHAPES;i++){
		ar[i].mode = 1;
		memset( &mp[i], 0, sizeof( TShapeProps ) );
		mp[i].wx = 10;
		mp[i].wy = 10;
		ar[i].x1 = 11 * ((i >> 2)+1);
		mp[i].color = random();	
		ar[i].y1 = 10 + 11 * ( i & 0x3 );
		
		iwork = random();
		iwork = ( 3 * iwork ) / 0x10000 + 1;
		if ( random() & 0x8000 ) iwork = -iwork;
		mp[i].dx = iwork;
		iwork = random();
		iwork = ( 3 * iwork ) / 0x10000 + 1;
		if ( random() & 0x8000 ) iwork = -iwork;
		mp[i].dy = iwork;
		
		ar[i].x2 = ar[i].x1 + mp[i].wx;
		ar[i].y2 = ar[i].y1 + mp[i].wy;
	}
	while ( !QuickExitCheck() ){
		for (i=0;i<NSHAPES;i++){
			MoveOne( ar, mp, i );
		}
	    Bdisp_PutDisp_DD();
	}
}

//
void F8_Handler(){
TMCSView mv;
	mv.browse();
}

// demonstrates the speed of direct draw operations
void F9_Handler(){
int i;
TBdispFillArea area;

	for (i=0;i<50;i++){
		area.x1 = random() * 350 / 0xFFFF;
		area.y1 = random() * 170 / 0xFFFF;
		area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
		area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
		area.mode = 1;
		Bdisp_AreaClr( &area, 2, random() );
		if ( QuickExitCheck() ) break;
	}
	for (i=0;i<50;i++){
		area.x1 = random() * 350 / 0xFFFF;
		area.y1 = random() * 170 / 0xFFFF;
		area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
		area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
		area.mode = 2;
		Bdisp_AreaClr( &area, 2, random() );
		if ( QuickExitCheck() ) break;
	}
}

// demonstrates the speed of VRAM-DMAC operations
void F10_Handler(){
int i;
TBdispFillArea area;

//	EnableColor( 0 );

	for (i=0;i<50;i++){
		area.x1 = random() * 350 / 0xFFFF;
		area.y1 = random() * 180 / 0xFFFF;
		area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
		area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
		area.mode = 1;
		Bdisp_AreaClr( &area, 1, random() );
	    Bdisp_PutDisp_DD();
		if ( QuickExitCheck() ) break;
	}
	for (i=0;i<50;i++){
		area.x1 = random() * 350 / 0xFFFF;
		area.y1 = random() * 180 / 0xFFFF;
		area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
		area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
		area.mode = 2;
		Bdisp_AreaClr( &area, 1, random() );
	    Bdisp_PutDisp_DD();
		if ( QuickExitCheck() ) break;
	}
}

// checksums
void F11_Handler(){
unsigned int i, checksum = 0;
unsigned char hb[15];
int key;
	StatusArea( "INSIGHT checksums" );

	MsgBoxPush( 6 );
// according to cfxm:
// http://www.omnimaga.org/index.php?PHPSESSID=8673ef5ea2e48c005dc66e3ea7ba42e8&topic=5610.msg144179#msg144179
//BIOS checksum (0x1FFFC):
//0x00..0x02FF + 0x0340..0x01FFBF
	for (i=0x80000000;i<=0x800002FF;i++){
		checksum += *(unsigned char*)i;
		if ( !(i & 0x0000FFFF) ){
			IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
			hb[8]=0;
			locate_OS( 3, 3 );
			Print( hb );
			Bdisp_PutDisp_DD();
		 }
	}
	for (i=0x80000340;i<=0x8001FFBF;i++){
		checksum += *(unsigned char*)i;
		if ( !(i & 0x0000FFFF) ){
			IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
			hb[8]=0;
			locate_OS( 3, 3 );
			Print( hb );
			Bdisp_PutDisp_DD();
		 }
	}
	IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
	hb[8]=0;
	locate_OS( 3, 3 );
	Print( hb );
	IntToHex( *(unsigned int*)0x8001FFFC, hb );
	hb[8]=0;
	locate_OS( 12, 3 );
	Print( hb );
	Bdisp_PutDisp_DD();

//OS checksum (0xB5FFF8):
//0x020000..0xB5FEAF + 0xB5FEF0..0xB5FFF7
	checksum = 0;
	for (i=0x80020000;i<=0x80B5FEAF;i++){
		checksum += *(unsigned char*)i;
		if ( !(i & 0x000FFFFF) ){
			IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
			hb[8]=0;
			locate_OS( 3, 4 );
			Print( hb );
			Bdisp_PutDisp_DD();
		 }
	}
	for (i=0x80B5FEF0;i<=0x80B5FFF7;i++){
		checksum += *(unsigned char*)i;
		IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
		hb[8]=0;
		locate_OS( 12, 4 );
		Print( hb );
		if ( !(i & 0x000FFFFF) ){
			IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
			hb[8]=0;
			locate_OS( 3, 4 );
			Print( hb );
			Bdisp_PutDisp_DD();
		 }
	}
	IntToHex( checksum, hb );	// converts the initial stack-pointer to a displayable hex-string
	hb[8]=0;
	locate_OS( 3, 4 );
	Print( hb );
	Bdisp_PutDisp_DD();
	IntToHex( checksum, hb );
	hb[8]=0;
	locate_OS( 3, 4 );
	Print( hb );
	IntToHex( *(unsigned int*)0x80B5FFF8, hb );
	hb[8]=0;
	locate_OS( 12, 4 );
	Print( hb );
    Bdisp_PutDisp_DD();
	GetKey( &key );
	MsgBoxPop();
}

/*
#include "..\bitmaps\truhe_auf.cpp"
#include "..\bitmaps\truhe_zu.cpp"
#include "..\bitmaps\pressluft01.cpp"
#include "..\bitmaps\pressluft02.cpp"
#include "..\bitmaps\pressluft03.cpp"
#include "..\bitmaps\pressluft04.cpp"
#include "..\bitmaps\pressluft05.cpp"
#include "..\bitmaps\pressluft06.cpp"
#include "..\bitmaps\pressluft07.cpp"
#include "..\bitmaps\pressluft08.cpp"
#include "..\bitmaps\pressluft09.cpp"
#include "..\bitmaps\pressluft10.cpp"
#include "..\bitmaps\pressluft11.cpp"
*/

#define __ALIEN_DEMO__
#undef __ALIEN_DEMO__

#define __ROBOTER_DEMO__
#undef __ROBOTER_DEMO__

#ifdef __ALIEN_DEMO__

#include "..\bitmaps\alien01.cpp"
#include "..\bitmaps\alien02.cpp"
#include "..\bitmaps\alien03.cpp"
#include "..\bitmaps\alien04.cpp"
#include "..\bitmaps\alien05.cpp"
#include "..\bitmaps\alien06.cpp"
#include "..\bitmaps\alien07.cpp"
#include "..\bitmaps\alien08.cpp"

#endif

#ifdef __ROBOTER_DEMO__

#include "..\bitmaps\Roboter01.cpp"
#include "..\bitmaps\Roboter02.cpp"
#include "..\bitmaps\Roboter03.cpp"
#include "..\bitmaps\Roboter04.cpp"
#include "..\bitmaps\Roboter05.cpp"
#include "..\bitmaps\Roboter06.cpp"
#include "..\bitmaps\Roboter07.cpp"
#include "..\bitmaps\Roboter08.cpp"
#include "..\bitmaps\Roboter09.cpp"
#include "..\bitmaps\Roboter10.cpp"
#include "..\bitmaps\Roboter11.cpp"
#include "..\bitmaps\Roboter12.cpp"
#include "..\bitmaps\Roboter13.cpp"
#include "..\bitmaps\Roboter14.cpp"
#include "..\bitmaps\Roboter15.cpp"
#include "..\bitmaps\Roboter16.cpp"

#endif

#define TEST4BITMAP_WIDTH 0x80
#define TEST4BITMAP_HEIGHT 0x40
#define TEST4BITMAP_SIZE TEST4BITMAP_WIDTH*TEST4BITMAP_HEIGHT/2
#define TEST16BITMAP_WIDTH 0x80
#define TEST16BITMAP_HEIGHT 0x40
#define TEST16BITMAP_SIZE TEST16BITMAP_WIDTH*TEST16BITMAP_HEIGHT
#define DESCX 1
#define DESCY 2
#define TESTX 60
#define TESTY 70
#define DELAY 1000

//#define XDIFF 24
#define XDIFF 3
#define YDIFF 1

//
void F13_Handler(){
TDispGraph Graph, Graph2;
int i, j, key;
unsigned int ticks;
unsigned char hb[15];
unsigned char Test4Bitmap[TEST4BITMAP_SIZE];
unsigned short Test16Bitmap[TEST16BITMAP_SIZE];
TBdispFillArea area;

	locate_OS( 1, 7 );
    PrintLine( "", 21 );

	for (i=0;i<0x8;i++){
		for (j=0;j<TEST4BITMAP_SIZE/8;j++){
			Test4Bitmap[ i*TEST4BITMAP_SIZE/8+j ] = ( i << 4 ) + i;
		}
	}
	for (i=0;i<TEST16BITMAP_SIZE;i++){
		switch ( 8*(i % TEST16BITMAP_WIDTH) / TEST16BITMAP_WIDTH ){
			case 0:
				Test16Bitmap[ i ] = 0x0000;
				break;
			case 1:
				Test16Bitmap[ i ] = 0x001F;
				break;
			case 2:
				Test16Bitmap[ i ] = 0x07E0;
				break;
			case 3:
				Test16Bitmap[ i ] = 0x07FF;
				break;
			case 4:
				Test16Bitmap[ i ] = 0xF800;
				break;
			case 5:
				Test16Bitmap[ i ] = 0xF81F;
				break;
			case 6:
				Test16Bitmap[ i ] = 0xFFE0;
				break;
			case 7:
				Test16Bitmap[ i ] = 0xFFFF;
				break;
		}
	}	
	
	Graph2.x = TESTX-10;
	Graph2.y = TESTY+10;
	Graph2.xofs = 0;
	Graph2.yofs = 0;
	Graph2.width = TEST16BITMAP_WIDTH;
	Graph2.height = TEST16BITMAP_HEIGHT;
	Graph2.colormode = 0x02;
	Graph2.zero4 = 0x2E;
	Graph2.P20_1 = 0xB9;
	Graph2.P20_2 = 0x40;
	Graph2.bitmap = (int)Test16Bitmap;
	Graph2.color_idx1 = 0x00;
	Graph2.color_idx2 = 0xFF;
	Graph2.color_idx3 = 0xFF;
	Graph2.P20_3 = 0x01;
	Graph2.writemodify = 0x01;	
	Graph2.writekind = 0x01;
	Graph2.zero6 = 0xFF;
	Graph2.one2 = 0x00;
	Graph2.transparency = 0;

	Graph.x = TESTX;
	Graph.y = TESTY;
	Graph.xofs = 0;
	Graph.yofs = 0;
	Graph.width = 0x5C;
	Graph.height = 0x40;
	Graph.colormode = 0x02;
	Graph.zero4 = 0x2E;
	Graph.P20_1 = 0xB9;
	Graph.P20_2 = 0x40;
	Graph.bitmap = 0x80576834;
	Graph.color_idx1 = 0x00;
	Graph.color_idx2 = 0xFF;
	Graph.color_idx3 = 0xFF;
	Graph.P20_3 = 0x01;
	Graph.writemodify = 0x01;	
	Graph.writekind = 0x01;
	Graph.zero6 = 0xFF;
	Graph.one2 = 0x00;
	Graph.transparency = 0;
	for (i=1;i<4;i=i+1){
		Bdisp_WriteGraphVRAM( &Graph2 );
		Graph.writemodify = i;	// normal, reverse, halftone
		Bdisp_WriteGraphVRAM( &Graph );
		locate_OS( DESCX, DESCY );
		PrintLine( "writemodify", 21 );
		itoa( i, hb );
		hb[8]=0;
		locate_OS( DESCX, DESCY+1 );
		Print( hb );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while (!RTC_Elapsed_ms( ticks, DELAY ));
	}

	Graph.writemodify = 0x01;	
	for (i=1;i<5;i=i+1){
		Bdisp_WriteGraphVRAM( &Graph2 );
		Graph.writekind = i;	// overwrite, OR, AND, XOR
		Bdisp_WriteGraphVRAM( &Graph );
		locate_OS( DESCX, DESCY );
		PrintLine( "writekind", 21 );
		itoa( i, hb );
		hb[8]=0;
		locate_OS( DESCX, DESCY+1 );
		Print( hb );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while (!RTC_Elapsed_ms( ticks, DELAY ));
	}
	Graph.writekind = 0x01;
	for (i=0;i<100;i=i+10){
		Bdisp_WriteGraphVRAM( &Graph2 );
		Graph.transparency = i;
		Bdisp_WriteGraphVRAM( &Graph );
		locate_OS( DESCX, DESCY );
		PrintLine( "transparency", 21 );
		itoa( i, hb );
		hb[8]=0;
		locate_OS( DESCX, DESCY+1 );
		Print( hb );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while (!RTC_Elapsed_ms( ticks, DELAY ));
		
		if ( QuickExitCheck() ) break;

	}
	Graph.x = TESTX;
	Graph.y = TESTY;
	Graph.xofs = 0;
	Graph.yofs = 0;
	Graph.width = 0x40;
	Graph.height = 0x18;
	Graph.colormode = 0x03;
	Graph.zero4 = 0x00;
	Graph.P20_1 = 0x20;
	Graph.P20_2 = 0x20;
	Graph.bitmap = 0x801E5CD0;	// SELECT-FKey-Icon
	Graph.color_idx1 = 0x01;
	Graph.color_idx2 = 0x00;
	Graph.color_idx3 = 0xFF;
	Graph.P20_3 = 0x20;
	Graph.writemodify = 0x01;
	Graph.writekind = 0x01;
	Graph.zero6 = 0x00;
	Graph.one2 = 0x01;
	for (i=0;i<100;i=i+10){
		Bdisp_WriteGraphVRAM( &Graph2 );
		Graph.transparency = i;
		Bdisp_WriteGraphVRAM( &Graph );
		locate_OS( DESCX, DESCY );
		PrintLine( "transparency", 21 );
		itoa( i, hb );
		hb[8]=0;
		locate_OS( DESCX, DESCY+1 );
		Print( hb );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while (!RTC_Elapsed_ms( ticks, DELAY ));
		
		if ( QuickExitCheck() ) break;

	}
	Graph.transparency = 0;
	
	Graph.x = TESTX;
	Graph.y = TESTY;
	Graph.xofs = 0;
	Graph.yofs = 0;
	Graph.width = TEST4BITMAP_WIDTH;
	Graph.height = TEST4BITMAP_HEIGHT;
	Graph.colormode = 0x01;
	Graph.zero4 = 0x00;
	Graph.P20_1 = 0x20;
	Graph.P20_2 = 0x20;
	Graph.bitmap = (int)Test4Bitmap;
	Graph.color_idx1 = 0x01;
	Graph.color_idx2 = 0xFF;
	Graph.color_idx3 = 0xFF;
	Graph.P20_3 = 0x20;
	Graph.writemodify = 0x01;
	Graph.writekind = 0x01;
	Graph.zero6 = 0x00;
	Graph.one2 = 0x01;
	for (i=0;i<100;i=i+10){
		Bdisp_WriteGraphVRAM( &Graph2 );
		Graph.transparency = i;
		Bdisp_WriteGraphVRAM( &Graph );
		locate_OS( DESCX, DESCY );
		PrintLine( "transparency", 21 );
		itoa( i, hb );
		hb[8]=0;
		locate_OS( DESCX, DESCY+1 );
		Print( hb );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while (!RTC_Elapsed_ms( ticks, DELAY ));
		
		if ( QuickExitCheck() ) break;

	}
	Graph.transparency = 0;
	
	Graph.x = 0x100;
	Graph.y = 0x80;
	Graph.xofs = 0;
	Graph.yofs = 0;
	Graph.width = 0x5C;
	Graph.height = 0x40;
	Graph.colormode = 0x02;
	Graph.zero4 = 0x2E;
	Graph.P20_1 = 0xB9;
	Graph.P20_2 = 0x40;
	Graph.color_idx1 = 0x00;
	Graph.color_idx2 = 0xFF;
	Graph.color_idx3 = 0xFF;
	Graph.P20_3 = 0x01;
	Graph.writemodify = 0x01;
	Graph.writekind = 0x01;
	Graph.zero6 = 0xFF;
	Graph.one2 = 0x00;
	Graph.transparency = 0;
//	Bdisp_WriteGraphVRAM( &Graph );
/*	
	for (i=0;i<100;i++){
		if ( i > 5 ) j = ( 100- i );
		else j = 1000- i*10;
		Graph.bitmap = (int)truhe_zu;
		Bdisp_WriteGraphVRAM( &Graph );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while ( !RTC_Elapsed_ms( ticks, j ) );
		Graph.bitmap = (int)truhe_auf;
		Bdisp_WriteGraphVRAM( &Graph );
		Bdisp_PutDisp_DD();
		ticks = RTC_GetTicks();
		while ( !RTC_Elapsed_ms( ticks, j ) );
	}
*/
#ifdef __ALIEN_DEMO__

	locate_OS( DESCX, DESCY );
	PrintLine( "Alien strolling", 21 );
	locate_OS( DESCX, DESCY+1 );
	PrintLine( "", 21 );

	Graph.x = 0x0;
	Graph.y = 0x50;
	for (i=0;i<100;i++){
		for (j=1;j<=8;j++){
			switch (j) {
				case 1 :
					Graph.width = alien01_WIDTH;
					Graph.height = alien01_HEIGHT;
					Graph.bitmap = (int)alien01;
					break;
				case 2 :
					Graph.width = alien02_WIDTH;
					Graph.height = alien02_HEIGHT;
					Graph.bitmap = (int)alien02;
					break;
				case 3 :
					Graph.width = alien03_WIDTH;
					Graph.height = alien03_HEIGHT;
					Graph.bitmap = (int)alien03;
					break;
				case 4 :
					Graph.width = alien04_WIDTH;
					Graph.height = alien04_HEIGHT;
					Graph.bitmap = (int)alien04;
					break;
				case 5 :
					Graph.width = alien05_WIDTH;
					Graph.height = alien05_HEIGHT;
					Graph.bitmap = (int)alien05;
					break;
				case 6 :
					Graph.width = alien06_WIDTH;
					Graph.height = alien06_HEIGHT;
					Graph.bitmap = (int)alien06;
					break;
				case 7 :
					Graph.width = alien07_WIDTH;
					Graph.height = alien07_HEIGHT;
					Graph.bitmap = (int)alien07;
					break;
				case 8 :
					Graph.width = alien08_WIDTH;
					Graph.height = alien08_HEIGHT;
					Graph.bitmap = (int)alien08;
					break;
			}		
			Bdisp_WriteGraphVRAM( &Graph );
			Bdisp_PutDisp_DD();
			
			if ( i == 10 ){
				locate_OS( DESCX, DESCY );
				PrintLine( "Alien hunting", 21 );
			}else if ( i < 10 ){
				ticks = RTC_GetTicks();
				while ( !RTC_Elapsed_ms( ticks, 200 ) );
			}
			
			area.x1 = Graph.x;
			area.y1 = Graph.y;
			area.x2 = Graph.x + Graph.width;
			if ( area.x2 >= 384 ) area.x2 = 383;
			area.y2 = Graph.y + Graph.height;
			area.mode = 0;
			Bdisp_AreaClr( &area, 1, 0xFFFF );
			
			Graph.x = Graph.x + XDIFF;
			if ( Graph.x >= 384 ) Graph.x = 0;
		}
		
		if ( QuickExitCheck() ) break;

	}
#endif
#ifdef __ROBOTER_DEMO__

	locate_OS( DESCX, DESCY );
	PrintLine( "Roboter", 21 );
	locate_OS( DESCX, DESCY+1 );
	PrintLine( "", 21 );

	Graph.x = 0x0;
	Graph.y = 0x0;
	for (i=0;i<100;i++){
		for (j=1;j<=16;j++){
			switch (j) {
				case 1 :
					Graph.width = roboter01_WIDTH;
					Graph.height = roboter01_HEIGHT;
					Graph.bitmap = (int)roboter01;
					break;
				case 2 :
					Graph.width = roboter02_WIDTH;
					Graph.height = roboter02_HEIGHT;
					Graph.bitmap = (int)roboter02;
					break;
				case 3 :
					Graph.width = roboter03_WIDTH;
					Graph.height = roboter03_HEIGHT;
					Graph.bitmap = (int)roboter03;
					break;
				case 4 :
					Graph.width = roboter04_WIDTH;
					Graph.height = roboter04_HEIGHT;
					Graph.bitmap = (int)roboter04;
					break;
				case 5 :
					Graph.width = roboter05_WIDTH;
					Graph.height = roboter05_HEIGHT;
					Graph.bitmap = (int)roboter05;
					break;
				case 6 :
					Graph.width = roboter06_WIDTH;
					Graph.height = roboter06_HEIGHT;
					Graph.bitmap = (int)roboter06;
					break;
				case 7 :
					Graph.width = roboter07_WIDTH;
					Graph.height = roboter07_HEIGHT;
					Graph.bitmap = (int)roboter07;
					break;
				case 8 :
					Graph.width = roboter08_WIDTH;
					Graph.height = roboter08_HEIGHT;
					Graph.bitmap = (int)roboter08;
					break;
				case 9 :
					Graph.width = roboter09_WIDTH;
					Graph.height = roboter09_HEIGHT;
					Graph.bitmap = (int)roboter09;
					break;
				case 10 :
					Graph.width = roboter10_WIDTH;
					Graph.height = roboter10_HEIGHT;
					Graph.bitmap = (int)roboter10;
					break;
				case 11 :
					Graph.width = roboter11_WIDTH;
					Graph.height = roboter11_HEIGHT;
					Graph.bitmap = (int)roboter11;
					break;
				case 12 :
					Graph.width = roboter12_WIDTH;
					Graph.height = roboter12_HEIGHT;
					Graph.bitmap = (int)roboter12;
					break;
				case 13 :
					Graph.width = roboter13_WIDTH;
					Graph.height = roboter13_HEIGHT;
					Graph.bitmap = (int)roboter13;
					break;
				case 14 :
					Graph.width = roboter14_WIDTH;
					Graph.height = roboter14_HEIGHT;
					Graph.bitmap = (int)roboter14;
					break;
				case 15 :
					Graph.width = roboter15_WIDTH;
					Graph.height = roboter15_HEIGHT;
					Graph.bitmap = (int)roboter15;
					break;
				case 16 :
					Graph.width = roboter16_WIDTH;
					Graph.height = roboter16_HEIGHT;
					Graph.bitmap = (int)roboter16;
					break;
			}		
			Bdisp_WriteGraphVRAM( &Graph );
			Bdisp_PutDisp_DD();
			
			area.x1 = Graph.x;
			area.y1 = Graph.y;
			area.x2 = Graph.x + Graph.width;
			if ( area.x2 >= 384 ) area.x2 = 383;
			area.y2 = Graph.y + Graph.height;
			if ( area.y2 >= 216 ) area.y2 = 215;
			area.mode = 0;
			Bdisp_AreaClr( &area, 1, 0xFFFF );
			
			if ( i == 10 ){
				locate_OS( DESCX, DESCY );
				//PrintLine( "Alien hunting", 21 );
			}else if ( i < 10 ){
				ticks = RTC_GetTicks();
//				while ( !RTC_Elapsed_ms( ticks, 200 ) );
			}
			
			Graph.x = Graph.x + XDIFF;
			if ( Graph.x >= 384 ) Graph.x = 0;
			Graph.y = Graph.y + YDIFF;
			if ( Graph.y >= 216 ) Graph.y = 0;
		}
		
		if ( QuickExitCheck() ) break;

	}
#endif


	locate_OS( 1, 7 );	
    Print( "EXIT return" );
	
    GetKey( &key );
	
	
}

//
void F14_Handler(){
int iresult, i, key, icontinue = 1;
unsigned char hb[22];
int x, y, y2, iconbase;
TDispGraph Graph;
	Bdisp_AllClr_VRAM();
	iconbase = 0;

	while( icontinue ){
		Graph.x = 0;
		Graph.y = 0;
		Graph.xofs = 0x00;
		Graph.yofs = 0x00;
		Graph.width = 0x40;
		Graph.height = 0x18;
		Graph.colormode = 0x03;
		Graph.zero4 = 0x00;
		Graph.P20_1 = 0x00;
		Graph.P20_2 = 0x00;
		Graph.bitmap = 0x801E5CD0;	// SELECT-FKey-Icon
		Graph.color_idx1 = 0x00;	// main color black
		Graph.color_idx2 = 0x07;	// back color white
		Graph.color_idx3 = 0xFF;
		Graph.P20_3 = 0x00;
		Graph.writemodify = 0x00;
		Graph.writekind = 0x00;
		Graph.zero6 = 0x00;
		Graph.one2 = 0x01;
		Graph.transparency = 0x0;
		y = 216-0x18-0x12;		// start at the bottom

		for (i=0;i<30;i++){
			x = ( i % 6 )*0x40;
			GetFKeyPtr( i + iconbase, &iresult );
			if ( i<6 ){
			// for the standard FKey-position use the regular display-function.
				FKey_Display( i, (void*)iresult );
			}else{
				if ( ( i % 6 ) == 0 ) y = y - ( 0x18 + 0x12 );
				// randomly select back color (as additional demo, how to change the color of a FKey-bitmap)
//				Graph.color_idx1 = 0x07 * random() / 0x10000;	// 0..6
				Graph.x = x;
				Graph.y = y + 0x12;
				Graph.bitmap = iresult;
				Bdisp_WriteGraphVRAM( &Graph );
			}
			WordToHex( i + iconbase, hb );
			hb[ 4 ] = 0;
			PrintMini( &x, &y, hb, 0x40, (unsigned int)0xFFFFFFFF, 0, 0, 0xF800, 0xFFFF, 1, 0 );
		}
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_UP : 
				iconbase += 6;
				break;
			case KEY_CTRL_DOWN : 
				iconbase -= 6;
				if ( iconbase < 0 ) iconbase = 0;
				break;
			case KEY_CTRL_LEFT : 
				iconbase += 30;
				break;
			case KEY_CTRL_RIGHT : 
				iconbase -= 30;
				if ( iconbase < 0 ) iconbase = 0;
				break;
			case KEY_CTRL_EXIT : 
				icontinue = 0;
				break;
		}
	}
}

//
void F15_Handler(){
int	ticks;
int progress;
	StatusArea( "INSIGHT Progressbar" );

	for (progress=0;progress<=10;progress++){
		ProgressBar(progress,10);
		ticks = RTC_GetTicks();
		while ( !RTC_Elapsed_ms( ticks, 500 ) );
	}
	MsgBoxPop();
}

// scrollbar demo
void F16_Handler(){
int	ticks;
int i, j;
TStandardScrollbar work;
TScrollbar scrollbar;
	scrollbar.I1               = 0x00000000;
	scrollbar.indicatormaximum = 0x00000200;  // maximum indicator range of the flexible scrollbar
	scrollbar.indicatorheight  = 0x00000040;
	scrollbar.I5               = 0x00000001;
	scrollbar.bartop           = 0x0008;
	scrollbar.barheight        = 0x0080;
	scrollbar.barwidth         = 0x00010;
	
	work[ 16 ] = 24;	// maximum indicator range of the standard scrollbar
	j = 0;
	while ( 1 ){
		StatusArea( "INSIGHT Scollbar" );
		for (i=0;i<19;i++){
			scrollbar.barleft 	   = 0x0010 + i*(scrollbar.barwidth+2);
//			scrollbar.indicatorpos = 0x00000010+2*i+j;
			scrollbar.indicatorpos = scrollbar.indicatormaximum * random() / 0xFFFF;
			Scrollbar( &scrollbar );
		}
		work[ 9 ] = work[ 16 ] * random() / 0xFFFF;;
		StandardScrollbar( work );
		Bdisp_PutDisp_DD();
		if ( QuickExitCheck() ) break;
		j+=15;
		if ( j > 300 ) j = 0;
	}
}

// direct 3pin access
void F17_Handler( int PortCR ){
unsigned int SerialPortDR, SerialPortCR;
unsigned short SerialPortMask, SerialPortMode, SerialPortMode0, SerialPortMode1;
unsigned char SerialPortOut, SerialPortIn;
unsigned int iresult, iDelay;
unsigned char hb[15];

	StatusArea( "INSIGHT direct 3pin access" );

	locate_OS( 3, 4 );
	Print( "Start" );
	Bdisp_PutDisp_DD();
	
// open the outer gate
	*(unsigned short*)P11CR = ( *(unsigned short*)P11CR & ~P11CR_ENABLE_SERIAL_MASK) | P11CR_ENABLE_SERIAL;
	*(unsigned char*)P11DR = *(unsigned char*)P11DR | P11DR_ENABLE_SERIAL;
	
// direct serial port
	SerialPortCR = PortCR;
	if ( PortCR == P7305_SERIAL_DIRECT_PORTCR ){
		SerialPortDR = P7305_SERIAL_DIRECT_PORTDR;
		
		// serial transmit pin
		// the following assignments have been determined experimetally and by deduction
		// 
		SerialPortOut  = 1 << P7305_SERIAL_TXD_BIT;
		SerialPortIn = 1 << P7305_SERIAL_RXD_BIT;
		SerialPortMask = ( 0x0003 << (P7305_SERIAL_TXD_BIT*2) ) | ( 0x0003 << (P7305_SERIAL_RXD_BIT*2) );
		SerialPortMode = ( 0x0001 << (P7305_SERIAL_TXD_BIT*2) ) | ( 0x0002 << (P7305_SERIAL_RXD_BIT*2) );
		iDelay = 10;
	}else if ( PortCR == P7305_ALT_SERIAL_DIRECT_PORTCR ){
		SerialPortDR = P7305_ALT_SERIAL_DIRECT_PORTDR;
		SerialPortOut = 1 << P7305_ALT_SERIAL_TXD_BIT;
		SerialPortIn  = 1 << P7305_ALT_SERIAL_RXD_BIT;
		SerialPortMask = ( 0x0003 << (P7305_ALT_SERIAL_TXD_BIT*2) ) | ( 0x0003 << (P7305_ALT_SERIAL_RXD_BIT*2) );
		SerialPortMode = ( 0x0001 << (P7305_ALT_SERIAL_TXD_BIT*2) ) | ( 0x0002 << (P7305_ALT_SERIAL_RXD_BIT*2) );
		
		SerialPortOut = 0xFF;
		SerialPortIn  = 0xFF;
		SerialPortMask = 0xFFFF;
		SerialPortMode = 0x5555;	// all to out
		SerialPortMode = 0xAAAA;	// all to in
		iDelay = 1000;
	}else{
		return;
	}
	
	// save the actual content (for debug purposes only)
	SerialPortMode0 = *(unsigned short*)SerialPortCR;
	*(unsigned short*)SerialPortCR = (SerialPortMode0 & (~SerialPortMask)) | SerialPortMode;

	// the following loop gives a sharp edged symmetric square wave of about 17 kHz.
	iresult = 5000000 / iDelay;
	while (iresult--){
		CMT_Delay_micros( iDelay );
		*(unsigned char*)SerialPortDR = *(unsigned char*)SerialPortDR & (~SerialPortOut);
		CMT_Delay_micros( iDelay );
		*(unsigned char*)SerialPortDR = *(unsigned char*)SerialPortDR | SerialPortOut;
	}
	SerialPortMode1 = *(unsigned short*)SerialPortCR; // for debug purposes only
	
	locate_OS( 3, 4 );
	Print( "Ready" );
	locate_OS( 3, 5 );
	LongToAscHex( SerialPortMode0, hb, 4 );   // for debug purposes only
	Print( hb );
	locate_OS( 3, 6 );
	LongToAscHex( SerialPortMode1, hb, 4 );   // for debug purposes only
	Print( hb );
	
// now check for input at the receive pin
	iresult = 0;
	while(1){
		if ( PRGM_GetKey() == KEY_PRGM_EXIT ) break;
		locate_OS( 3, 7 );
		LongToAscHex( *(unsigned char*)SerialPortDR, hb, 2 );
		Print( hb );
		locate_OS( 10, 7 );
		LongToAscHex( iresult++, hb, 8 );
		Print( hb );
		Bdisp_PutDisp_DD();
	}
	
	*(unsigned short*)SerialPortCR = SerialPortMode0;
	
// close the outer gate
	*(unsigned char*)P11DR = (*(unsigned char*)P11DR & ~P11DR_ENABLE_SERIAL) | 0x08;
	*(unsigned short*)P11CR = *(unsigned short*)P11CR | P11CR_ENABLE_SERIAL_MASK;
}

#define SETUP_YOFFSET 24
#define SETUP_YDIFF 17
#define SETUPHEIGHT 6*11
#define SETUPMAXBASE 0xC8 - SETUPHEIGHT

// setup
void F19_Handler(){
int iresult, i, key, icontinue = 1;
unsigned char hb[22];
int x, y, y2, ibase;
	StatusArea( "Setup demo" );
	ibase = 0;
	while( icontinue ){
		for (i=0;i<SETUPHEIGHT;i++){
			ByteToHex( i + ibase, hb );
			hb[2] = ':';
			ByteToHex( GetSetupSetting( ibase + i ), hb+3 );
			x = ( i % 6 )*0x40;
			y = SETUP_YOFFSET + ( i / 6 )*SETUP_YDIFF;
			hb[ 5 ] = 0;
			PrintMini( &x, &y, hb, 0x40, (unsigned int)0xFFFFFFFF, 0, 0, 0x0000, 0xFFFF, 1, 0 );
		}
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_DOWN : 
				ibase += 6;
				if ( ibase >= SETUPMAXBASE ) ibase = SETUPMAXBASE;
				break;
			case KEY_CTRL_UP : 
				ibase -= 6;
				if ( ibase < 0 ) ibase = 0;
				break;
			case KEY_CTRL_RIGHT : 
				ibase += SETUPHEIGHT;
				if ( ibase >= SETUPMAXBASE ) ibase = SETUPMAXBASE;
				break;
			case KEY_CTRL_LEFT : 
				ibase -= SETUPHEIGHT;
				if ( ibase < 0 ) ibase = 0;
				break;
			case KEY_CTRL_EXIT : 
				icontinue = 0;
				break;
		}
	}
}

void F20_Handler(){
int y, x, key;
unsigned int start_address;
unsigned char hb[22];
TStringList asciizz;
	StatusArea( "TStringList demo" );
	asciizz.AddString( "ABC9" );
	asciizz.AddString( "ABC1" );
	asciizz.AddString( "ABC34" );
	asciizz.AddString( "ABCwe" );
	asciizz.AddString( "ABC45" );
	asciizz.AddString( "ABCsx" );
	asciizz.AddString( "ABCas" );
	asciizz.AddString( "ABCer" );
	asciizz.AddString( "ABCsss" );
	y = 24;
	x = 0;
	asciizz.Sort( SortStrDescending );
	asciizz.GoBeginOfList();
	while ( 1 ){
		PrintMini( &x, &y, (unsigned char*)asciizz.Line(), 0x40, (unsigned int)0xFFFFFFFF, 0, 0, 0xF800, 0xFFFF, 1, 0 );
		x = 0;
		y = y + 18;
		if ( asciizz.IsEndOfList() ) break;
		asciizz.NextLine();
	}
	GetKey( &key );
}

const char heading[] = " *** TIntArrayView demo ***";
const char F1LABEL[] = "HEX";
const char F2LABEL[] = "ABCDEFG";


void F21_Handler(){
TIntArrayView x;
void*ptr;
unsigned char hb[15];
int key;
unsigned int start_address;

	x.SetFKey( -1 ); 
	GetFKeyPtr( 1, &ptr );
	x.SetFKey( 0, ptr, FKT_BITMAP ); 
	x.SetFKey( 1, F1LABEL, FKT_STRING ); 
	GetFKeyPtr( 2, &ptr );
	x.SetFKey( 2, ptr, FKT_BITMAP ); 
	GetFKeyPtr( 3, &ptr );
	x.SetFKey( 3, ptr, FKT_BITMAP ); 
	x.SetFKey( 4, F2LABEL, FKT_STRING ); 
	GetFKeyPtr( 5, &ptr );
//	x.SetFKey( 5, ptr, FKT_BITMAP ); 
	
	/*
	LongToAscHex( (int)ptr, hb, 8 );
	locate_OS( 3, 6 );
	Print( hb );
	GetKey( &key );
	
	start_address = (unsigned int)&x;
	memviewer( &start_address, 0 );
	*/
	
	x.SetHeading( (char*)heading );
	x.InitArray( 10, 4 );
	x.browse();
}

void F22_Handler(){
}

//
void F23_Handler(){
}

void F25_Handler(){
	TestMode( 1 );
}

void F26_Handler(){
// used to verify syscalls. 
int key, iresult, idata_len, idata = INSIGHT_SYSCALL_VERIFY_UNLOCK_VALUE;
// the next statement has to be uncommented once to unlock this Handler.
//	iresult = MCSPutVar2( INSIGHTDIRNAME, INSIGHT_SYSCALL_VERIFY_UNLOCK, sizeof( idata ), &idata );
	iresult = MCSGetDlen2( INSIGHTDIRNAME, INSIGHT_SYSCALL_VERIFY_UNLOCK, &idata_len );
	if ( !iresult ){
		if ( idata_len == sizeof( idata )){
			iresult = MCSGetData1( 0, idata_len, &idata );
			if ( !iresult ){
				if (idata!=INSIGHT_SYSCALL_VERIFY_UNLOCK_VALUE) iresult = 1;
			}
		}else iresult = 1;
	}
	if (iresult){
		MsgBoxPush( 3 );
		locate_OS( 3, 3 );
		Print( "Locked!" );
		GetKey( &key );
		MsgBoxPop();
	}else Verify_Syscalls();
}

void F27_Handler(){
}
void F28_Handler(){
}
void F29_Handler(){
}
void F30_Handler(){
}

// sub-menu
void F24_Handler(){
int key;
int iContinue = 1;
	while (iContinue){
		StatusArea( "INSIGHT 4. sub" );
		PrintXY( 1, 1, "  F1 Testmode (cfxm)", 0, 0 );
		PrintXY( 1, 2, "  F2 syscall verify", 0, 0 );
//		PrintXY( 1, 3, "  F3 ", 0, 0 );
//		PrintXY( 1, 4, "  F4 ", 0, 0 );
//		PrintXY( 1, 5, "  F5 ", 0, 0 );
//		PrintXY( 1, 6, "  F6 next", 0, 0 );
		PrintXY( 1, 7, "  EXIT return", 0, 0 );
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_F1 : F25_Handler(); break;
			case KEY_CTRL_F2 : F26_Handler(); break;
			case KEY_CTRL_F3 : F27_Handler(); break;
			case KEY_CTRL_F4 : F28_Handler(); break;
			case KEY_CTRL_F5 : F29_Handler(); break;
			case KEY_CTRL_F6 : F30_Handler(); break;
			case KEY_CTRL_EXIT : iContinue = 0; break;
		}
  }
}

// sub-menu
void F18_Handler(){
int key;
int iContinue = 1;
	while (iContinue){
		StatusArea( "INSIGHT 3. sub" );
		PrintXY( 1, 1, "  F1 Setup", 0, 0 );
		PrintXY( 1, 2, "  F2 StrList", 0, 0 );
		PrintXY( 1, 3, "  F3 ListView", 0, 0 );
//		PrintXY( 1, 4, "  F4 ", 0, 0 );
//		PrintXY( 1, 5, "  F5 ", 0, 0 );
		PrintXY( 1, 6, "  F6 next", 0, 0 );
		PrintXY( 1, 7, "  EXIT return", 0, 0 );
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_F1 : F19_Handler(); break;
			case KEY_CTRL_F2 : F20_Handler(); break;
			case KEY_CTRL_F3 : F21_Handler(); break;
			case KEY_CTRL_F4 : F22_Handler(); break;
			case KEY_CTRL_F5 : F23_Handler(); break;
			case KEY_CTRL_F6 : F24_Handler(); break;
			case KEY_CTRL_EXIT : iContinue = 0; break;
		}
  }
}

// sub-menu
void F12_Handler(){
int key;
int iContinue = 1;
	while (iContinue){
		StatusArea( "INSIGHT 2. sub" );
		PrintXY( 1, 1, "  F1 WriteGraph", 0, 0 );
		PrintXY( 1, 2, "  F2 FKey icons", 0, 0 );
		PrintXY( 1, 3, "  F3 Progressbar demo", 0, 0 );
		PrintXY( 1, 4, "  F4 Scrollbar demo", 0, 0 );
		PrintXY( 1, 5, "  F5 direct 3pin", 0, 0 );
		PrintXY( 1, 6, "  F6 next", 0, 0 );
		PrintXY( 1, 7, "  EXIT return", 0, 0 );
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_F1 : F13_Handler(); break;
			case KEY_CTRL_F2 : F14_Handler(); break;
			case KEY_CTRL_F3 : F15_Handler(); break;
			case KEY_CTRL_F4 : F16_Handler(); break;
			case KEY_CTRL_F5 : F17_Handler( P7305_SERIAL_DIRECT_PORTCR ); break;
			case KEY_CTRL_F6 : F18_Handler(); break;
			case KEY_CTRL_EXIT : iContinue = 0; break;
		}
	}
}

// sub-menu
void F6_Handler(){
int key;
int iContinue = 1;
	while (iContinue){
		StatusArea( "INSIGHT 1. sub" );
		PrintXY( 1, 1, "  F1 display", 0, 0 );
		PrintXY( 1, 2, "  F2 MCS view", 0, 0 );
		PrintXY( 1, 3, "  F3 display DD demo", 0, 0 );
		PrintXY( 1, 4, "  F4 display VRAM demo", 0, 0 );
		PrintXY( 1, 5, "  F5 Checksums (cfxm)", 0, 0 );
		PrintXY( 1, 6, "  F6 next", 0, 0 );
		PrintXY( 1, 7, "  EXIT return", 0, 0 );
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_F1 : F7_Handler(); break;
			case KEY_CTRL_F2 : F8_Handler(); break;
			case KEY_CTRL_F3 : F9_Handler(); break;
			case KEY_CTRL_F4 : F10_Handler(); break;
			case KEY_CTRL_F5 : F11_Handler(); break;
			case KEY_CTRL_F6 : F12_Handler(); break;
			case KEY_CTRL_EXIT : iContinue = 0; break;
		}
	}
}

//
void LightChain(){
unsigned int ticks = RTC_GetTicks();
int x=0, y=0;
unsigned short color = 0;
	DrawFrame( random() );
	while ( PRGM_GetKey() != KEY_PRGM_EXIT ){
		DirectDrawRectangle( x, y, x+4, y+4, color );
		if ( color ) color = 0;
		else color = 0xFFFF;
		
		if ( x == 0 ){
			y = y + 4;
			if ( y == 220 ){
				x = x + 4;
			}
		}else if ( x == 392 ){
			y = y - 4;
			if ( y == 0 ){
				x = 0;
				DrawFrame( random() );
				break;
			}
		}else{
			x = x + 4;
		}
		/*
		DirectDrawRectangle( 0, 10, 5, 15, 0xF800 );
		DirectDrawRectangle( 0, 215, 7, 223, 0xF800 );
		DirectDrawRectangle( 384, 215, 398, 223, 0xF800 );
		*/
		ticks = RTC_GetTicks();
		while (!RTC_Elapsed_ms( ticks, 25 ));
	}
}

const unsigned int default_fkeys[] = 
  { 0x0000FFFF,0,0x0000FFFF,0,0x0000FFFF,0,0x0000FFFF,0,0x0000FFFF,0,0x0000FFFF,0 };

//
void G3A_main( void ){
int stack = (int)GetStackPtr();
int key;
int iContinue = 1;
unsigned char hb[15];
char heading[25];
//TStatusGlyphDefinition sgd;

	random( RTC_GetTicks() );	// randomize the random-function
	EnableColor( 1 );
	//  EnableDisplayHeader( 0, 0 );
	EnableStatusArea( 0 );	// necessary, if the status area should be used by system functions!
	DefineStatusAreaFlags( DSA_SETDEFAULT, 0, 0, 0 );	// necessary, if the status area should be used by system functions!
	DefineStatusAreaFlags( 3, SAF_BATTERY|SAF_TEXT|SAF_GLYPH, 0, 0 );
	DefineStatusMessage( "INSIGHT", 1, 1, 7 );
//	APP_EACT_StatusIcon( 6 );
//	SetupItem17_StatusIcon();
//	Test1B0E();
	DisplayStatusArea();
	Bdisp_PutDisp_DD();

	IntToHex( stack, hb );	// converts the initial stack-pointer to a displayable hex-string
	hb[8]=0;
	AsmTest();
	AsmLibTest();
	AsmTest2();

	LightChain();

	// a lot of Built-Ins remap the return values of the F-Keys to 1, 2, 3, 4, 5 and/or 6, 
	// instead of using the default-keycodes.
	// the following calls reset the special code-mapping to the default values.
	// if an add-in is run from RAM, the host is LINK, which remaps
	// in this case the following statements are necessary to provide for proper FKey-response.
	if ( ( GetPR() && 0xFFFF0000 ) != 0x00300000 ){
		Set_FKeys1( 0, (unsigned int*)default_fkeys );
		Set_FKeys2( 0 );
		strcpy( heading, "INSIGHT main menu (RAM)" );
	}else{
		strcpy( heading, "INSIGHT main menu" );
	}
	while (iContinue){
		StatusArea( heading );
		PrintXY( 1, 1, "  F1 memory", 0, 0 );
		PrintXY( 1, 2, "  F2 keyboard codes", 0, 0 );
		PrintXY( 1, 3, "  F3 keyboard ports", 0, 0 );
		PrintXY( 1, 4, "  F4 battery", 0, 0 );
		PrintXY( 1, 5, "  F5 RTC", 0, 0 );
		PrintXY( 1, 6, "  F6 next", 0, 0 );
		locate_OS( 1, 8 );
		Print( "Stack: " );
		Print( hb );
		GetKey( &key );
		switch ( key ){
			case KEY_CTRL_F1 : F1_Handler(); break;
			case KEY_CTRL_F2 : F2_Handler(); break;
			case KEY_CTRL_F3 : F3_Handler(); break;
			case KEY_CTRL_F4 : F4_Handler(); break;
			case KEY_CTRL_F5 : F5_Handler(); break;
			case KEY_CTRL_F6 : F6_Handler(); break;
		}
	}
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

}

