extern "C" {

#include "keyboard.hpp"
#include "keyboard_syscalls.h"
#include "disp_tools.hpp"
#include "display_tools.h"
#include "convert_syscalls.h"
#include "convert_tools.h"
#include "app_syscalls.h"
#include "mcs_syscalls.h"
#include "STD_syscalls.h"
#include "RTC_syscalls.h"
#include "system_syscalls.h"
#include "fxCG_display.h"
#include "misc_tools.h"
#include "filebios.h"
#include "BFILE_syscalls.h"
#include "Serial_syscalls.h"
#include "LineEditors.h"
#include "fxCG_registers.h"
#include "MemViewClass.hpp"

int AsmTest( void );
int GetPR( void );

//
void DebugInt( int value ){
int key;
unsigned char hb[10];
	hb[8]=0;
	locate_OS( 1, 1 );
	Print( hb );
	Print( "<<<" );
	GetKey( &key );
}

//
int MENUreturn( void ){
int key;
	locate_OS( 3, 3 );
	Print( "Returns on MENU" );
	locate_OS( 3, 4 );
	Print( "only!" );
	locate_OS( 3, 5 );
	Print( "F1 if OK" );
	GetKey( &key );
	return ( key == KEY_CTRL_F1 );
}

//
int TimedReturn( void ){
int key;
	MsgBoxPush( 6 );
	locate_OS( 3, 3 );
	Print( "Returns after a" );
	locate_OS( 3, 4 );
	Print( "few seconds!" );
	locate_OS( 3, 5 );
	Print( "F1 if OK" );
	GetKey( &key );
	MsgBoxPop();
	return ( key == KEY_CTRL_F1 );
}



#define MCSTESTDIRNAME "@MCSDIR"
#define MCSTESTVARNAME "MCSVAR"
#define MCSTESTSIZE 8


#define UBC7705 0xFFFFFF90
#define UBC7720 0xA4FFFF90
#define BDRB 0
#define BDMRB 1*4
#define BRCR 2*4
#define BETR 3*4
#define BARB 4*4
#define BAMRB 5*4
#define BBRB 6*4
#define BRSR 7*4
#define BARA 8*4
#define BAMRA 9*4
#define BBRA 10*4
#define BRDR 11*4
#define BASRA 13*4
#define BASRB 14*4

#define PROCESSOR_VERSION_REGISTER 0xFF000030
#define PRODUCT_VERSION_REGISTER 0xFF000044

#define FILENAMESIZE 0x10A

// const unsigned char cpattern[ FILENAMESIZE ] = "\\\\fls0\\*.G3A";
const unsigned char cpattern[ FILENAMESIZE ] = "\\\\fls0\\*.*";
//const unsigned char cpattern[ FILENAMESIZE ] = "\\\\fls0\\*.BKP";

const unsigned short TestGlyph[ 18 ] = 
{ 0x0000, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0F00, 
  0x3FC0, 
  0x3FC0, 
  0x7FE0, 
  0x7FE0, 
  0x7FE0, 
  0x7FE0, 
  0x3FC0, 
  0x3FC0, 
  0x0F00, 
  0x0000, 
  0x0000, 
  0x0000, 
  0x0000
};

const unsigned char TripleGlyph[ 72 ] = 
{ 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 
  0x00, 0x3C, 0x00,
  0x00, 0x3C, 0x00,
  0x00, 0xFF, 0x00,
  0x00, 0xFF, 0x00,
  0x0F, 0xFF, 0xF0,
  0x0F, 0xFF, 0xF0,
  0x3F, 0xFF, 0xFC,
  0x3F, 0xFF, 0xFC,
  0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF,
  0x3F, 0xFF, 0xFC,
  0x3F, 0xFF, 0xFC,
  0x0F, 0xFF, 0xF0,
  0x0F, 0xFF, 0xF0,
  0x00, 0xFF, 0x00,
  0x00, 0xFF, 0x00,
  0x00, 0x3C, 0x00,
  0x00, 0x3C, 0x00,
  0x00, 0x00, 0x00,
  0x00, 0x00, 0x00,
  0x00, 0x00, 0x00
};
  
#define PSCREEN 0x88000000
#define TEST_TIMER 10
#define StackTestSize 100
  
//
void Timer_Test(){
static int c = 0;
static unsigned char MCSOpenItem[8];
static unsigned int StackTest[StackTestSize];
int i, j = (int)GetStackPtr();
	MCSGetOpenItem( MCSOpenItem );
	c = *(unsigned int*)P7305_EXTRA_TMU5_COUNT;
	StackTest[0] = 0x55AA55AA;
	StackTest[1] = GetPR();
	StackTest[2] = (unsigned int)((void*)Timer_Test);
	for (i=3;i<StackTestSize-1;i++){
		StackTest[ i ] = *(unsigned int*)(j+(i-1)*4);
	}
	StackTest[StackTestSize-1] = 0xAA55AA55;
	
/*
int i = GetPR();
unsigned char hb[15];
int x = 280, y = 5;
//	LongToAscHex( i++, hb, 8 );
//    i = (int)GetStackPtr()+3*4;
	
	LongToAscHex( i, hb, 8 );
	PrintMini( &x, &y, hb, 0x40, 
	           (unsigned int)0xFFFFFFFF, (int)0, (int)0, (int)0xF800, (int)0x001F, (int)1,  (int)0 );
	LongToAscHex( c++, hb, 8 );
	x = 100;
	PrintMini( &x, &y, hb, 0x40, 
	           (unsigned int)0xFFFFFFFF, (int)0, (int)0, (int)0xF800, (int)0x0000, (int)1,  (int)0 );
	Bdisp_PutDisp_DD();
	*/
/*
	DrawFrame( random() );
static unsigned short x = 0, y = 0;
static unsigned short color = 0;

		DirectDrawRectangle( x, y, x+4, y+4, color );
		if ( color ) color = 0;
		else color = 0xFFFF;
		
		if ( x == 0 ){
			y = y + 4;
			if ( y == 220 ){
				x = x + 4;
			}
		}else if ( x == 392 ){
			y = y - 4;
			if ( y == 0 ){
				x = 0;
				DrawFrame( random() );
			}
		}else{
			x = x + 4;
		}
		*/
}  
  
//
void VerifySyscall( int syscallno ){
int key, iresult, iresult2;
int i, ticks;
unsigned char hb[15];
unsigned char MCSbuffer[MCSTESTSIZE];
TBdispFillArea area;
FILE_INFO fileinfo;
int FindHandle;
FONTCHARACTER pattern[ FILENAMESIZE ];
FONTCHARACTER foundfile[ FILENAMESIZE ];
unsigned char cfoundfile[ FILENAMESIZE ];
unsigned char serial_mode[ 6 ];
unsigned char work[ 28 ];
TShape shape;
int x, y, edpos;
unsigned int start_address;
TDispGraph Graph;
int (*ptrFunction)( unsigned char *, int , int  );  // declare an int function pointer
TBGRbitmap bgrbmp;
TStandardScrollbar uswork;
TScrollbar scrollbar;
TMemView mv;

	Bfile_StrToName_ncpy( pattern, cpattern, FILENAMESIZE );

	memset( MCSbuffer, 0x44, MCSTESTSIZE - 1 );
	memset( MCSbuffer, 0x55, MCSTESTSIZE / 2 );
	memset( &fileinfo, 0, sizeof( FILE_INFO ) );
	MCSbuffer[MCSTESTSIZE-1] = 0;
	DisplayStatusArea();
	MsgBoxPush( 6 );
	
	locate_OS( 3, 2 );
	Print( "Verifying: " );
	WordToHex( syscallno, hb );
	hb[4]=0;
	Print( hb );
	
	Bdisp_PutDisp_DD();
	
	random( RTC_GetTicks() );
	
	switch (syscallno){
		case 0x01BE :
			shape.x1 = 10;
			shape.y1 = 10;
			shape.x2 = 30;
			shape.y2 = 30;
			shape.f[0] = 2;	// always 2
			shape.f[1] = 5;	// box
			shape.f[2] = 1;	// 1
			shape.f[3] = 1;	// 1
			Bdisp_ShapeBase3XVRAM( &shape );
			break;
		case 0x01C7 :
			shape.x1 = 150;
			shape.y1 = 100;
			shape.x2 = 50;
			shape.y2 = 0;
			shape.f[0] = 2;	// 2
			shape.f[1] = 6;	// circle
			shape.f[2] = 1;	// 1
			shape.f[3] = 1;	// 1
			memset( work, 0, sizeof( work ) );
			work[0] = 1;	// target = VRAM
			Bdisp_ShapeBase( work, &shape, 0xF800, 2, 0, 0 );
			break;
		case 0x023C :
			x = 120;
			y = 5;
			// P4: 0 => use back_color, use workbench (back_color=0x1F)
			// P4: 0x52 => do not use back_color, do not use workbench (back_color=0x1F)
			// P4: 0x02 => do not use back_color, use workbench (back_color=0x1F)
			// P4: 0x50 => use back_color, do not use workbench (back_color=0x1F)
			// P4: 0x10 => use back_color, use workbench (back_color=0x1F)
			// P4: 0x40 => use back_color, do not use workbench (back_color=0x1F)
			// P4: 0x42 => do not use back_color, do not use workbench (back_color=0x1F)
			// P4: 0x12 => do not use back_color, use workbench (back_color=0x1F)
			// P4: 0x04 => use back_color, use workbench (back_color=0x1F)
			
			// P4: 0 => use back_color, use workbench (back_color=0xFFFF)
			// P4: 0x52 => do not use back_color, do not use workbench (back_color=0xFFFF)
			// P4: 0x02 => do not use back_color, use workbench (back_color=0xFFFF)
			// P4: 0x50 => use back_color, do not use workbench (back_color=0xFFFF)
			// P4: 0x10 => use back_color, use workbench (back_color=0xFFFF)
			// P4: 0x40 => use back_color, do not use workbench (back_color=0xFFFF)
			PrintMini( &x, &y, (unsigned char*)cpattern, 0x44, 
			           (unsigned int)0xFFFFFFFF, (int)0, (int)0, (int)0xF800, (int)0x001F, (int)1,  (int)0 );
			Bdisp_PutDisp_DD();
			while ((*(int*)0xA44B0000));
			while (!(*(int*)0xA44B0000));
			break;
		case 0x02B2 :
			if ( TimedReturn() ){
				for (i=0;i<50;i++){
					area.x1 = random() * 350 / 0xFFFF;
					area.y1 = random() * 180 / 0xFFFF;
					area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
					area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
					area.mode = 1;
					Bdisp_AreaClr( &area, 2, random() );
				}
//				ticks = RTC_GetTicks();
//				while ( !RTC_Elapsed_ms( ticks, 2000 ) );
				area.x1 = random() * 350 / 0xFFFF;
				area.y1 = random() * 180 / 0xFFFF;
				area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
				area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
				area.mode = 0;
				Bdisp_AreaClr( &area, 2, 0xFFFF );
//				ticks = RTC_GetTicks();
//				while ( !RTC_Elapsed_ms( ticks, 2000 ) );
				for (i=0;i<50;i++){
					area.x1 = random() * 350 / 0xFFFF;
					area.y1 = random() * 180 / 0xFFFF;
					area.x2 = area.x1 + 10 + random() * (374-area.x1) / 0xFFFF;
					area.y2 = area.y1 + 10 + random() * (206-area.y1) / 0xFFFF;
					area.mode = 2;
					Bdisp_AreaClr( &area, 2, random() );
				}
//				ticks = RTC_GetTicks();
//				while ( !RTC_Elapsed_ms( ticks, 2000 ) );
				break;
			}
		case 0x08C7 :
			Cursor_SetFlashOn( 5 );
			locate_OS( 3, 4 );
			IntToHex( i, hb );
			hb[8]=0;
			Print( hb );
			GetKey( &key );
			*(int*)0xE5200000 = 0x55555555;
			*(int*)0xE5007000 = 0x55555551;
			*(int*)0xE5008000 = 0x55555552;
			*(int*)0xE5017000 = 0x55555553;
			*(int*)0xE5018000 = 0x55555554;
			break;
		case 0x08D9 :
			iresult = Timer_Install( TEST_TIMER, (void*)Timer_Test, 500 );
			locate_OS( 3, 4 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			break;
		case 0x08DA :
		    iresult = Timer_Deinstall( TEST_TIMER );
			locate_OS( 3, 4 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			break;
		case 0x08DB :
			iresult = Timer_Start( TEST_TIMER );
			locate_OS( 3, 4 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			break;
		case 0x08DC :
			iresult = Timer_Stop( TEST_TIMER );
			locate_OS( 3, 4 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			break;
		case 0x0C5A : 
			uswork[ 0x09 ] = 9;
			uswork[ 0x10 ] = 24;
			StandardScrollbar( uswork ); 
			break;

			for (x=0;x<10;x++){
				locate_OS( 3, 4 );
				IntToHex( x, hb );
				hb[8]=0;
				Print( hb );
				for (y=5;y<25;y+=5){
					locate_OS( 3, 5 );
					IntToHex( y, hb );
					hb[8]=0;
					Print( hb );
					uswork[ 0x09 ] = x;
					uswork[ 0x10 ] = y;
					StandardScrollbar( uswork ); 
					GetKey( &key );
					if ( key == KEY_CTRL_EXIT ) break;
				}
				if ( key == KEY_CTRL_EXIT ) break;
			}
			uswork[ 0x09 ] = x;
			uswork[ 0x10 ] = y;
			StandardScrollbar( uswork ); 
			GetKey( &key );

			break;
		case 0x0C6B : if ( MENUreturn() ) APP_FINANCE( 0, 0 ); break;
		case 0x0EA7 : TestMode( 1 ); break;
		case 0x11D6 : 
			ticks = RTC_GetTicks();
			for (i=0;i<500;i++){
				CMT_Delay_100micros( 80 );
			}
			ticks = ( RTC_GetTicks() - ticks ) / 128;
			locate_OS( 3, 3 );
			IntToHex( ticks, hb );	// should yield 0x100!
			hb[8]=0;
			Print( hb );
			break;
		case 0x121D : 
			area.x1 = 0;
			area.y1 = (5-1)*24;
			area.x2 = 21*18;
			area.y2 = area.y1 + 3*24;
			area.mode = 1;
			Bdisp_AreaClr( &area, 1, 0xF800 );
		
			memcpy( hb, "12345", 6 );
			edpos = 0;
			iresult = InputAny( hb, 4, 5, 8, edpos );
			locate_OS( 3, 3 );
			switch (iresult){
				case KEY_CTRL_EXE :
					Print( "EXE" );
					break;
				case KEY_CTRL_EXIT :
					Print( "EXIT" );
					break;
			}
			locate_OS( 3, 4 );
			Print( hb );

			break;
		case 0x12F3 : 
			GetFKeyPtr( 0x65, &iresult );
			FKey_Display( 0, (void*)iresult );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1516 : 
			iresult = MCS_DeleteDirectory( MCSTESTDIRNAME );
			locate_OS( 3, 3 );
			Print( "delete " ); Print( MCSTESTDIRNAME );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x151A : 
			iresult = MCS_WriteItem( MCSTESTDIRNAME, MCSTESTVARNAME, 0xD4, MCSTESTSIZE, (int)MCSbuffer );
			locate_OS( 3, 3 );
			Print( MCSTESTDIRNAME ); Print( " " ); Print( MCSTESTVARNAME );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1532 : 
			iresult = MCS_GetCapa( &iresult2 );
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			locate_OS( 3, 4 );
			IntToHex( iresult2, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1543 : 
			iresult = MCS_GetMainMemoryStart();
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x154B : 
			iresult = MCS_CreateDirectory( MCSTESTDIRNAME );
			locate_OS( 3, 3 );
			Print( "create " ); Print( MCSTESTDIRNAME );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x154D : 
			iresult2 = 0x78ABCDEF;
			iresult = MCSPutVar2( MCSTESTDIRNAME, MCSTESTVARNAME, MCSTESTSIZE, MCSbuffer );
			locate_OS( 3, 3 );
			Print( MCSTESTDIRNAME ); Print( " " ); Print( MCSTESTVARNAME );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			locate_OS( 3, 5 );
			IntToHex( iresult2, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1552 : 
			iresult2 = 0x12345678;
			iresult = MCSOvwDat2( MCSTESTDIRNAME, MCSTESTVARNAME, MCSTESTSIZE, MCSbuffer, 0 );
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			locate_OS( 3, 4 );
			IntToHex( iresult2, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1558 : 
			iresult = MCSDelVar2( MCSTESTDIRNAME, MCSTESTVARNAME );
			locate_OS( 3, 3 );
			Print( MCSTESTDIRNAME ); Print( " " ); Print( MCSTESTVARNAME );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1562 : 
			iresult = MCSGetDlen2( MCSTESTDIRNAME, MCSTESTVARNAME, &iresult2 );
			locate_OS( 3, 3 );
			Print( MCSTESTDIRNAME ); Print( " " ); Print( MCSTESTVARNAME );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			locate_OS( 3, 5 );
			IntToHex( iresult2, hb );
			hb[8]=0;
			Print( hb );
			break;
		case 0x1563 : 
			memset( MCSbuffer, 0x66, MCSTESTSIZE - 1 );
			iresult = MCSGetData1( 0, MCSTESTSIZE, MCSbuffer );
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			locate_OS( 3, 4 );
			Print( MCSbuffer );
			break;
		case 0x1841 : 
			iresult = 0x12345678;
			locate_OS( 3, 3 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			locate_OS( 3, 4 );
			break;
		case 0x1A0A : 
			for (i=0;i<20;i++){
				scrollbar.I1               = 0x00000000; // 0x00000000; 0x00
				scrollbar.indicatormaximum = 0x00000200; // 0x00000138;
				scrollbar.indicatorheight  = 0x00000040; // 0x000000A8;
				scrollbar.indicatorpos     = 0x00000010+2*i; // 0x00000000;
				scrollbar.I5               = 0x00000001; // 0x00000001; 0x10
				scrollbar.bartop           = 0x0010; // 0x0000;
				scrollbar.barheight        = 0x0088; // 0x00A8;
				scrollbar.barwidth         = 0x00010; // 0x0006;
				scrollbar.barleft 	       = 0x0010 + i*(scrollbar.barwidth+2); // 0x017A;
				Scrollbar( &scrollbar );
			}
			break;
		case 0x1BB4 : 
			ticks = RTC_GetTicks();
			for (i=0;i<250;i++){
				OS_InnerWait_ms( 8 );
			}
			ticks = RTC_GetTicks() - ticks;
			locate_OS( 3, 3 );
			IntToHex( ticks, hb );	// should yield 0x100!
			hb[8]=0;
			Print( hb );
			break;	
		case 0x1BB7 : 
			serial_mode[0] = 0;
			serial_mode[1] = 9;
			serial_mode[2] = 2;
			serial_mode[3] = 0;
			serial_mode[4] = 1;
			serial_mode[5] = 0;
			iresult = Serial_Open( serial_mode );
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );	// should yield 0x0!
			hb[8]=0;
			Print( hb );
			break;
		case 0x1BB8 : 
			iresult = Serial_Close( 0 );
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );	// should yield 0x0!
			hb[8]=0;
			Print( hb );
			break;
		case 0x1BBD :
		    while(	PRGM_GetKey() != 47 ){
				iresult = Serial_DirectTransmitOneByte( 'A' );
			}
			locate_OS( 3, 3 );
			IntToHex( iresult, hb );	// should yield 0x100!
			hb[8]=0;
			Print( hb );
			break;
		case 0x1D86 : 
			Bdisp_HeaderFill( 8, 9 );
			Bdisp_PutDisp_DD();
			ticks = RTC_GetTicks();
			while ( !RTC_Elapsed_ms( ticks, 2000 ) );
			break;	
		case 0x1D87 : 
			Bdisp_HeaderFill( 8, 9 );
			Bdisp_HeaderFill2( 100, 200, 1, 5 );
			Bdisp_PutDisp_DD();
			ticks = RTC_GetTicks();
			while ( !RTC_Elapsed_ms( ticks, 2000 ) );
			break;	
		case 0x1D89 : 
			Bdisp_HeaderFill( 3, 2 );
			BatteryIcon( 1 );
			Bdisp_PutDisp_DD();
			ticks = RTC_GetTicks();
			while ( !RTC_Elapsed_ms( ticks, 2000 ) );
			break;	
		case 0x1D8A : 
			Bdisp_HeaderFill( 3, 2 );
			KeyboardIcon( 1 );
			RadIcon( 1 );
			RealIcon( 1 );
			NormIcon( 1 );
			d_c_Icon( 1 );
			LineIcon( 1 );
			Bdisp_HeaderText();
//			Bdisp_HeaderText2();
			Bdisp_PutDisp_DD();
			ticks = RTC_GetTicks();
			while ( !RTC_Elapsed_ms( ticks, 2000 ) );
			break;	
		case 0x1DB7 :
			i = Bfile_FindFirst( pattern, &FindHandle, foundfile, &fileinfo );
			locate_OS( 3, 3 );
			if (i){
				IntToHex( i, hb );
				hb[8]=0;
				Print( hb );
			}else{
//				i = Bfile_FindNext( FindHandle, foundfile, &fileinfo );
//				i = Bfile_FindNext( FindHandle, foundfile, &fileinfo );

				mv.SetAddress( (unsigned int)&fileinfo );
			    mv.browse();
			    Bdisp_AllClr_VRAM();

				Bfile_NameToStr_ncpy( cfoundfile, foundfile, FILENAMESIZE );
				Print( cfoundfile );
				locate_OS( 3, 4 );
				IntToHex( fileinfo.id, hb );
				hb[8]=0;
				Print( hb );
				locate_OS( 3, 5 );
				IntToHex( FindHandle, hb );
				hb[8]=0;
				Print( hb );
				i = Bfile_FindClose( FindHandle );
				locate_OS( 3, 6 );
				IntToHex( i, hb );
				hb[8]=0;
				Print( hb );
				
				
			}
			break;
		case 0x1E05 : if ( MENUreturn() ) APP_SYSTEM_POWER( 0 ); break;
		case 0x1E07 : if ( MENUreturn() ) APP_SYSTEM_BATTERY( 0 ); break;
		case 0x1E0A : if ( MENUreturn() ) APP_SYSTEM_DISPLAY( 0 ); break;
		case 0x1E0D : if ( MENUreturn() ) APP_SYSTEM_LANGUAGE( 0 ); break;
		case 0x1E13 : if ( MENUreturn() ) APP_SYSTEM(); break;
		case 0x1E17 : if ( MENUreturn() ) APP_SYSTEM_RESET(); break;
		case 0x1E23 : ResetAllDialog(); break;
		case 0x1E34 : APP_SYSTEM_VERSION(); break;
		case 0x1E4B : DisplayMessageBox( "Helo world!" ); break;
		case 0x1E62 : 
			locate_OS( 3, 4 );
			Print( "Mind this!" );
			SaveVRAM_1(); 
			break;
		case 0x1E63 : LoadVRAM_1(); break;
		case 0x1E9F : 
			iresult = (int)GetAppName( hb );
			locate_OS( 3, 3 );
			Print( "AppName:" );
			locate_OS( 3, 4 );
			Print( hb );
			break;
		case 0x1EF7 :
//			Bdisp_WriteArea( (void*)0xA8000000, 384, 216-24, (void*)0x8064AE88, 0, 0, 0 );			
//			Bdisp_WriteArea( (void*)0xA8000000, 384, 216-24, (void*)0x8064AE88, 0, 8, 0 );			
			bgrbmp.width = 384;
			bgrbmp.height = 216-24;
			bgrbmp.unknown1 = 0x10;
			bgrbmp.unknown2 = 0x0;
			bgrbmp.unknown3 = 1;
			bgrbmp.unknown4 = 0xF800;
			bgrbmp.bitmap = (void*)0x8054F45C;
			WriteBackground( (void*)0xA8000000, bgrbmp.width, bgrbmp.height, &bgrbmp, 0, 24, 0 );			
			break;
		case 0x1EF8 :
			SetBackGround( 1 );
			break;
		case 0x8000 :
			SetSetupSetting( 0x17, 0x0F );
			ptrFunction = (int (*)( unsigned char *, int , int  ))0x801E1ED0;
			iresult = (*ptrFunction)( "Heading: ", 8, 1 );
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
			
		case 0xFFFF :
			DisplayMainMenu();
			break;
			HourGlass();
			CMT_Delay_100micros( 5000 );
			HourGlass();
			CMT_Delay_100micros( 5000 );
			HourGlass();
			CMT_Delay_100micros( 5000 );
			HourGlass();
			CMT_Delay_100micros( 5000 );
			HourGlass();
			CMT_Delay_100micros( 5000 );
			HourGlass();
			CMT_Delay_100micros( 5000 );
			HourGlass();
			CMT_Delay_100micros( 5000 );

			break;
			iresult = memcmp3( "ABC\0Y", "ABC\0X", 5 );
			locate_OS( 3, 3 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			break;
			iresult = Timer_Install( 1, (void*)Timer_Test, 500 );
			locate_OS( 3, 4 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			Timer_Start( 1 );
			/*
			Timer_Start( 1 );
			iresult = Timer_Deinstall( 10 );
			locate_OS( 3, 5 );
			LongToAscHex( iresult, hb, 8 );
			Print( hb );
			*/
			
			break;
//			i = Syscall1816( Syscall02A7(), 0x4000 );
//			i = Syscall1816( 4, 0x4000 );	// disables clear option
//			i = Syscall1816( 4, 0x8000 );	// disables auto option
			i = Syscall1816( 4, 0x0000 );	// disables none
//			i = Syscall1816( 4, 0x2000 );	// disables none
//			i = Syscall1816( 4, 0xFFFF );	// disables all
//			i = Syscall1816( 4, 0x0001 );	// disables black
//			i = Syscall1816( 4, 0x0002 );	// disables blue
//			i = Syscall1816( 4, 0x0004 );	// disables red
//			i = Syscall1816( 4, 0x0008 );	// disables magenta
//			i = Syscall1816( 4, 0x0010 );	// disables green
//			i = Syscall1816( 4, 0x0020 );	// disables cyan
//			i = Syscall1816( 4, 0x0040 );	// disables yellow
//			i = Syscall1816( 4, 0x0080 );	// disables white
			if ( i != -1 ){
				Syscall02A4( 1, i );
				Syscall02A9( i );
			}
			locate_OS( 3, 4 );
			LongToAscHex( i, hb, 2 );
			Print( hb );
			break;
			Bdisp_Fill_VRAM( 0x1F1F, 4 );
			GetKey( &key );
			break;
			APP_Program( 1, 0 );
			break;
			CharacterSelectDialog();
			break;
			EnableColor( 1 );
			iresult = *(unsigned int*)(0xFD8014A8);
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
			Test1E44();
			break;
			Bfile_StrToName_ncpy( pattern, cpattern, FILENAMESIZE );
			iresult = SMEM_FindFirst( pattern, foundfile );
			mv.SetAddress( (unsigned int)&foundfile );
		    mv.browse();
		    Bdisp_AllClr_VRAM();
			locate_OS( 3, 4 );
			IntToHex( iresult, hb );
			hb[8]=0;
			Print( hb );
			break;
			Test17BC( 0x628 );
			
//			PrintMiniGlyph( 10, 10, (unsigned short*)TestGlyph, 0x52, 0x0C, 0, 0, 0, 0, 0xF800, 0, 0 );
//			PrintMiniGlyph( 10, 10, (unsigned short*)0x8045FFD6, 0x40, 0x0C, 0, 0, 0, 0, 0xF800, 0, 0 );
//			locate_OS( 1, 1 );
//			PrintLine2( 0, 1, "ABC", 0, -1, 10, 0, 7 );			
			// locate_OS( 1, 2 );
			// PrintLine2( 0, 1, "ABC", 0, -1, 10, 1, 7 );			
//			PrintLine2( 0, 1, "ABC", 0, -1, 10, 0, 7 );			
//			PrintCXY( 0, 0, "A", 0x51, -1, 0x001F, 0xF800, 1, 0 );
//			PrintGlyph( 0, 0, (unsigned char*)TripleGlyph, 0x51, 0x001F, 0xF800, 0 );
//			locate_OS( 3, 4 );
//			DispInt( 123, 4 );
//			DrawFrameWorkbench( 10, 10, 100, 100, 0 );
	
			
			start_address = (unsigned int)work;
//			memviewer( &start_address, 0 );

			locate_OS( 3, 3 );
			Print( "AppName:" );

			Graph.x = 0;
			Graph.y = 0;
			Graph.xofs = 0;
			Graph.yofs = 0;
			Graph.width = 0x40;
			Graph.height = 0x18;
			Graph.colormode = 0x03;
			Graph.zero4 = 0x00;
			Graph.P20_1 = 0x20;
			Graph.P20_2 = 0x20;
			Graph.bitmap = 0x801E5CD0;
			Graph.color_idx1 = 0x00;
			Graph.color_idx2 = 0x07;
			Graph.color_idx3 = 0xFF;
			Graph.P20_3 = 0x20;
			Graph.writemodify = 0x01;
			Graph.writekind = 0x01;
			Graph.zero6 = 0x00;
			Graph.one2 = 0x01;
			Graph.transparency = 0;
			
			Bdisp_WriteGraphVRAM( &Graph );
			
			Graph.x = 0x80;
			Graph.y = 0;
			Graph.xofs = 0;
			Graph.yofs = 0;
			Graph.width = 0x40;
			Graph.height = 0x18;
			Graph.colormode = 0x03;
			Graph.zero4 = 0x00;
			Graph.P20_1 = 0x20;
			Graph.P20_2 = 0x20;
			Graph.bitmap = 0x801E5CD0;
			Graph.color_idx1 = 0x01;
			Graph.color_idx2 = 0x07;
			Graph.color_idx3 = 0xFF;
			Graph.P20_3 = 0x20;
			Graph.writemodify = 0x01;
			Graph.writekind = 0x04;
			Graph.zero6 = 0x00;
			Graph.one2 = 0x01;
			Graph.transparency = 39;
			Bdisp_WriteGraphVRAM( &Graph );
			
			Graph.x = 0x40;
			Graph.y = 0;
			Graph.transparency = 0;
			Bdisp_WriteGraphVRAM( &Graph );
			
			Graph.x = 0x80;
			Graph.y = 30;
			Graph.transparency = 49;
			Bdisp_WriteGraphVRAM( &Graph );
			
			Graph.x = 0x40;
			Graph.y = 30;
			Graph.transparency = 59;
			Bdisp_WriteGraphVRAM( &Graph );
			
			Graph.x = 0x80;
			Graph.y = 0x80;
			Graph.xofs = 0;
			Graph.yofs = 0;
			Graph.width = 0x5C;
			Graph.height = 0x40;
			Graph.colormode = 0x02;
			Graph.zero4 = 0x2E;
			Graph.P20_1 = 0xB9;
			Graph.P20_2 = 0x40;
			Graph.bitmap = 0x80576834;
			Graph.color_idx1 = 0x01;
			Graph.color_idx2 = 0x05;
			Graph.color_idx3 = 0xFF;
			Graph.P20_3 = 0x01;
			Graph.writemodify = 0x01;
			Graph.writekind = 0x01;
			Graph.zero6 = 0xFF;
			Graph.one2 = 0x00;
			Graph.transparency = 0;
			Bdisp_WriteGraphVRAM( &Graph );
			
			
			while ( key == KEY_CTRL_EXIT ) GetKey( &key );
			while ( key != KEY_CTRL_EXIT ) GetKey( &key );
			break;
	}
	
	GetKey( &key );
	MsgBoxPop();
}

/* main menu icon "Link"
0000005C 
00000018
00000000
00000000
0000005C
00000040
02
2E
B9
40
80576834
00
FF
FF
01 
01 
01 
FF 
00
00000000
*/

/* battery icon
00000000
00000000
00000000
00000000
00000010
00000016
02
FF
FF
FF
805E5DF4
00
07
FF
00
01
01
00
07
00000000
*/

// SYSCALL=h'154B;MCS_CreateDirectory;int MCS_CreateDirectory( unsigned char*dir );$(MCS_SC)

#define YMAX 8
//
const unsigned short syscall_list[] = { 
0x01BE,		//	 Bdisp_ShapeBase3XVRAM
0x01C7,		//	 Bdisp_ShapeBase
0x023C,		//   PrintMini
0x02B2,     //   Bdisp_AreaClr
0x08C7,     //   SetFlashOn
0x08D9,     //   Timer_Install
0x08DA,     //   Timer_Deinstall
0x08DB,     //   Timer_Start
0x08DC,     //   Timer_Stop
0x0C5A,     //   ScrollBar
0x0C6B,     //   APP_FINANCE
0x0EA7,     //   Testmode
0x11D6,		//	 CMT_Delay
0x121D,		//	 DisplayMBString 
0x12F3,		//   GetFKeyPtr
0x1516,     //   MCS_DeleteDir
0x151A,     //   MCS_WriteItem
0x1532,     //   MCS_GetCapa
0x1543,     //   MCS_Start
0x154B,     //   MCS_CreateDir
0x154D,     //   MCSPutVar2
0x1552,     //   MCSOvwDat2
0x1558,     //   MCSDelVar2
0x1562,     //   MCSGetDlen2
0x1563,     //   MCSGetData1
0x1841,		//   ItoHex
0x1A0A,		//	 ScrollbarDisplay
0x1BB4,		//	 OS_InnerWait_ms 
0x1BB7,		//	 Serial_Open
0x1BB8,		//	 Serial_Close
0x1BBD,		//	 Serial_DTransOne
0x1D86,		//	 Bdisp_HeaderFill
0x1D87,		//	 Bdisp_HeaderFill2
0x1D89,		//	 BatteryIcon
0x1D8A,		//	 KeyboardIcon
0x1DB7,		//	 Bfile_FindFirst
0x1e05,     //   APP_SYS.POWER
0x1e07,     //   APP_SYS.BATTERY
0x1e0A,     //   APP_SYS.DISPLAY
0x1e0D,     //   APP_SYS.LANGUAGE
0x1e13,     //   APP_SYSTEM
0x1e17,     //   APP_SYS.RESET
0x1e23,     //   ResetAllDialog
0x1e34,     //   APP_SYS.VERSION
0x1e4B,     //   DisplayMessage
0x1e62,     //   SaveVRAM_1
0x1e63,     //   LoadVRAM_1
0x1e9F,     //   GetAppName
0x1EF7,		//	 Bdisp_WriteArea
0x1EF8,		//   SetBackGround
0x8000,     //   InputNumber
0xFFFF,     //   experimental code
0 };

//
const unsigned char syscall_names[] = 
"...ShapeBase3XVRAM\0"
"Bdisp_ShapeBase\0"
"PrintMini\0"
"Bdisp_AreaClr\0"
"SetFlashOn\0"
"Timer_Install\0"
"Timer_Deinstall\0"
"Timer_Start\0"
"Timer_Stop\0"
"ScrollBar\0"
"APP_FINANCE\0"
"Testmode\0"
"CMT_Delay\0"
"DisplayMBString\0"
"GetFKeyPtr\0"
"MCS_DeleteDir\0"
"MCS_WriteItem\0"
"MCS_GetCapa\0"
"MCS_Start\0"
"MCS_CreateDir\0"
"MCSPutVar2\0"
"MCSOvwDat2\0"
"MCSDelVar2\0"
"MCSGetDlen2\0"
"MCSGetData1\0"
"ItoHex\0"
"ScrollbarDisplay\0"
"OS_InnerWait_ms\0"
"Serial_Open\0"
"Serial_Close\0"
"Serial_DTransOne\0"
"Bdisp_HeaderFill\0"
"Bdisp_HeaderFill2\0"
"BatteryIcon\0"
"KeyboardIcon\0"
"Bfile_FindFirst\0"
"APP_SYS.POWER\0"
"APP_SYS.BATTERY\0"
"APP_SYS.DISPLAY\0"
"APP_SYS.LANGUAGE\0"
"APP_SYSTEM\0"
"APP_SYS.RESET\0"
"ResetAllDialog\0"
"APP_SYS.VERSION\0"
"DisplayMessage\0"
"SaveVRAM_1\0"
"LoadVRAM_1\0"
"GetAppName\0"
"Bdisp_WriteArea\0"
"SetBackGround\0"
"InputNumber\0"
"experimental\0"
;

//
unsigned char*GetSyscallDescr( int i ){
int j = 0, k = 0;
	while ( j != i ){
		if ( !syscall_names[ k ] ){
			if ( !syscall_names[ k + 1 ] ) break;
			j++;
		}
		k++;
	};
	return (unsigned char*)(syscall_names + k);
}

// syscall verify
void Verify_Syscalls(){
int key;
int iContinue = 1;
int iStart = 0, i, iY, iCurrent, iEnde, iYmax, j;
unsigned char hb[15];
  iEnde = 0;
  while (syscall_list[iEnde]) iEnde++;

  iCurrent = 1;
  while (iContinue){
	StatusArea( "INSIGHT syscall verify" );
	i = iStart;
	iY = 1;
	while ( iY <= YMAX ){
		locate_OS( 1, iY );
		if ( syscall_list[i] ){
			WordToHex( syscall_list[i], hb );
			hb[4]=0;
			if (iCurrent == iY) Print_OS( hb, 1, 0 );
			else Print( hb );
			Print( " " );Print( GetSyscallDescr( i ) );
			i++;
		};
		iY++;
	}
    GetKey( &key );
	
	iYmax = iEnde - iStart;
//	DebugInt( iYmax );
	if ( iYmax > YMAX ) iYmax = YMAX;
	
    switch ( key ){
      case KEY_CTRL_UP : 
		if (iCurrent > 1 ) iCurrent--; else if (iStart > 0 ) iStart--; 
		break;
      case KEY_CTRL_DOWN : 
		if (iCurrent < iYmax ) iCurrent++; else if (iCurrent == YMAX) if (iStart+YMAX < iEnde ) iStart++; 
		break;
      case KEY_CTRL_RIGHT : 
		for (j=0;j<7;j++)
			if (iCurrent < iYmax ) iCurrent++; else if (iCurrent == YMAX) if (iStart+YMAX < iEnde ) iStart++;
		break;
      case KEY_CTRL_LEFT : 
		for (j=0;j<7;j++)
			if (iCurrent > 1 ) iCurrent--; else if (iStart > 0 ) iStart--;
		break;
      case KEY_CTRL_EXE : VerifySyscall( syscall_list[iStart+iCurrent-1] ); break;
      case KEY_CTRL_EXIT : iContinue = 0; break;
    }
  }

return;
}


}

